# ----------------------------------------------
# - Page: General Operations, SOQL
# ----------------------------------------------

module SfdcSe
  class Driver
  	
  	# -----------------------------
  	def raw_login(username, password, host)
	  binding = RForce::Binding.new %{https://#{host}/services/Soap/u/36.0}
	  resp = binding.login( username, password )
	  server_url = resp[:loginResponse][:result][:serverUrl]
	  uri = URI(server_url)
	  {
	    :instance_url => %{#{uri.scheme}://#{uri.host}},
	    :oauth_token => resp[:loginResponse][:result][:sessionId]
	  }
	end
	# -----------------------------

	# -----------------------------
	def restforce_client(options)
	  Restforce.new( raw_login(options[:username], options[:password], (options[:sandbox] ? 'test.salesforce.com' : 'login.salesforce.com') ).merge(:api_version => '36.0') )
	end
	# -----------------------------

  	# -----------------------------
    # get_LocaleSidKey(blnSandbox, sUserName, sPassword)
    # => Returns the Org LocaleSidKey
    def get_LocaleSidKey(blnSandbox, sUserName, sPassword)

      ENV['http_proxy']='http://webproxy.merck.com:8080'
      ENV['https_proxy']='https://webproxy.merck.com:8080'

    	client=restforce_client({:sandbox => blnSandbox, :username => sUserName, :password => sPassword})
    	resp_SOQL=client.query("SELECT LocaleSidKey FROM User WHERE Username = '#{sUserName}'")
    	if resp_SOQL.size == 1
    		resp_SOQL.each do |r|
    			return r['LocaleSidKey']
    		end
    	end

      ENV.delete('HTTP_PROXY')
      ENV.delete('HTTPS_PROXY')
    end
    # -----------------------------

    # -----------------------------
     # set_LocaleSidKey(blnSandbox, sUserName, sPassword, LocaleSidKey)
    # => Returns true or false
    def set_LocaleSidKey(blnSandbox, sUserName, sPassword, sLocaleSidKey)
      ENV['http_proxy']='http://webproxy.merck.com:8080'
      ENV['https_proxy']='https://webproxy.merck.com:8080'

    	blnRep=false

    	client=restforce_client({:sandbox => blnSandbox, :username => sUserName, :password => sPassword})
    	resp_SOQL=client.query("SELECT Id,LocaleSidKey FROM User WHERE Username = '#{sUserName}'")

    	if resp_SOQL.size > 0
    		resp_SOQL.each do |r|
    			if r['LocaleSidKey'] != sLocaleSidKey
    				client.update('User', Id: r['Id'], LocaleSidKey: sLocaleSidKey) ? blnRep=true : blnRep=false
    			elsif r['LocaleSidKey'] == sLocaleSidKey
    				blnRep=true
    			end
      		end
    	end

      ENV.delete('HTTP_PROXY')
      ENV.delete('HTTPS_PROXY')
      
    	return blnRep
	end
	# -----------------------------  

  end
end