# ----------------------------------------------
# - Page: Email Alerts
# ----------------------------------------------

module SfdcSe
  class Driver
  	
  	# -----------------------------
  	# click_btn_EmailAlertContinue
  	# => Clicks the 'Continue' button on the Email Alerts page
  	#
  	def click_Btn_EmailAlertContinue
  		@driver.find_element(:xpath => "//input[@class='btn' and @title='Continue']").click
  	end
  	# -----------------------------

  	# -----------------------------
  	# click_btn_EmailAlertsEditCancel
  	# => Clicks the 'Cancle' button on the Email Alerts Edit page
  	#
  	def click_btn_EmailAlertsEditCancel
  		@driver.find_element(:xpath => "//td[@id='bottomButtonRow']/input[@class='btn' and @title='Cancel']").click
  	end
  	# -----------------------------

    # -----------------------------
    # click_btn_EmailAlertEditSave
    # => Clicks the 'Save' button on the Email Alerts Edit page
    #
    def click_btn_EmailAlertEditSave
      # - Click the Save button and handle Alert if prompted; always Accept.
      @driver.find_element(:xpath => "//td[@id='topButtonRow']/input[@class='btn' and @title='Save']").click
      sMsg=""
      a=@driver.switch_to.alert rescue "Exception happened"
      if !(a == "Exception happened")
        sMsg= "Accepting Alert: #{a.text}"
        a.accept
      end
      
      # - Click the 'Bread Crumb' link to return to full Email Alert List View
      @driver.find_element(:xpath => "//div[@class='ptBreadcrumb']/a").click

      # - Return Text from Alert, if present
      return sMsg
    end
    # -----------------------------
    
    # -----------------------------
    # click_btn_EmailAlertsNew
    # => Clicks the 'New Email Alert' button on the Email Alerts page
    #
    def click_btn_EmailAlertsNew
      @driver.find_element(:xpath => "//input[@class='btn' and @title='New Email Alert']").click
    end
    # -----------------------------

  	# -----------------------------
    # get_EmailAlertsView_Options
    # => returns all the elements for the Email Alerts dropdown
    #
  	def get_EmailAlertsViewOptions
  		return @driver.find_elements(:xpath => "//select[@id='fcf' and @title='View:']/option")
  	end
  	# -----------------------------

  	# -----------------------------
    # get_EmailAlertsTable
    # => returns all the elements for the Email Alerts Table
  	def get_EmailAlertsTable
  		return @driver.find_elements(:xpath => "//table[@class='list']/tbody/tr")
  	end
  	# -----------------------------

  	# -----------------------------
    # get_EmailAlertsEditTable
    # => returns all the elements for the Email Alerts Edit Table
  	def get_EmailAlertsEditTable
  		return @driver.find_elements(:xpath => "//table[@class='detailList']/tbody/tr")
  	end
  	# -----------------------------

  	# -----------------------------
    # set_EmailAlerts_View
    # => sViewName = string value of the Sharing Setting option to select
    # => Return = true or false
    # =>    true  = setting of view were successful
    # =>    false = setting of view had an error
    #
  	def set_EmailAlerts_View(sViewName)
  		blnViewSet=false
  		begin
  			get_EmailAlertsViewOptions.each do |option|
  				if option.text == sViewName
  					option.click unless option.selected?
  					blnViewSet=true
  					return blnViewSet
  				end
  			end
  		rescue
  			puts $!
	    	puts $@
  		end
  		return blnViewSet
  	end
  	# -----------------------------

  	# -----------------------------
  	# click_Edit_EmailAlertsTable
  	# => sDescriptionName = string value of the Email Alert to click Edit
  	# => Return = true or false
  	# =>  	true = value was found and 'edit' clicked
  	# =>  	false =value was not found or had an error
  	#
  	def click_Edit_EmailAlertsTable(sDescriptionName)
  		blnEdit=false
  		get_EmailAlertsTable.each do |row|
  			if row.find_element(:xpath => "./th[1]").text == sDescriptionName
  				row.find_element(:xpath => "./td[1]/a[1]").click
  				blnEdit=true
  				break
  			end
  		end
  		return blnEdit
  	end
  	# -----------------------------

  	# -----------------------------
  	# get_EmailAlert_Configuration
  	# => Return = Hash {Key= Field Name/Type, Value=Field Value}
  	#
  	def get_EmailAlert_Configuration
  		response=Hash.new
  		get_EmailAlertsEditTable.each_with_index do |row, idx|
  			case idx
  			when 0,1
				# 0 = Description, 1 = Uniique Name
  				response[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")]=row.find_element(:xpath => "./td[2]/div/input").attribute("value") unless row.find_elements(:xpath => "./td[1]//*").size == 0
  			when 2
  				# - 2 = Object
  				response[row.find_element(:xpath => "./td[1]").text.gsub("*\n", "")]=row.find_element(:xpath => "./td[2]").text
  			when 4, 7, 8
  				# - 4,7 = Blank Row, 8 = Text, no configurable item
  				# - Do nothing, row not required
  			when 3
  				# - 3 = Email Template
  				response[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")]=row.find_element(:xpath => "./td[2]/div/span/input").attribute("value") unless row.find_elements(:xpath => "./td[1]//*").size == 0
  			when 5
  				# - 5 = Recipient Type
  				$sSearchOpt=row.find_element(:xpath => "./td[2]/div/select/option[@selected='']").text
  				$sForField=row.find_element(:xpath => "./td[2]/div/input[@id='searchValue_userFilter']").attribute("value")
  				response[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")]="#{$sSearchOpt};#{$sForField}"
  			when 6
  				# - 6 = Recipents
  				# - Get Selected Recipients
  				$aSelected=[]
  				row.find_elements(:xpath => "./td[2]/div/table/tbody/tr/td[3]/select/option").each do |sr|
  					$aSelected.push(sr.text)
  				end
  				response[row.find_element(:xpath => "./td[1]").text.gsub("*\n", "")]=$aSelected
  			when 9
  				# - 9 = Additional Emails
  				response[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")]=row.find_element(:xpath => "./td[2]/textarea").text
  			when 10
  				# - 10 = From Email Address
  				response[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")]=row.find_element(:xpath => "./td[2]/div/select/option[@selected='selected']").text
  			when 11
  				# - 11 = Checkbox; Make this address the default From email address for this object's email alerts
  				row.find_element(:xpath => "./td[2]/input").attribute("checked").nil? ? response[row.find_element(:xpath => "./td[2]/label").text]="false" : response[row.find_element(:xpath => "./td[2]/label").text]=row.find_element(:xpath => "./td[2]/input").attribute("checked")
  				# response[row.find_element(:xpath => "./td[2]/label").text]=row.find_element(:xpath => "./td[2]/input").attribute("value")
  			end
  		end
  		return response
  	end
  	# -----------------------------


    # -----------------------------
    # set_EmailAlert_Configuration
    # => sObjName = string value of the object to set
    # => hObjValues = Email Alert Field Hash {Field, Value}
    # => addnew = Boolean, defaults to false unless true is passed
    #     - Set to true to create a new Email Alert (rather then adjusting the configuration of an existing one)
    # => return = true/false
    #     - True = Email Alert Configuration was updated
    #     - False = Email Alert Configration was NOT updated
    #
    def set_EmailAlert_Configuration(sObjName, hObjValues, addnew=false)
      addnew=false unless addnew==true
      blnUpdateReturn=false
      r=0

      while r < get_EmailAlertsEditTable.length
        case r
        when 0,1
        # 0 = Description, 1 = Uniique Name
          if !(hObjValues[sObjName][get_EmailAlertsEditTable[r].find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] == get_EmailAlertsEditTable[r].find_element(:xpath => "./td[2]/div/input").attribute("value"))
            get_EmailAlertsEditTable[r].find_element(:xpath => "./td[2]/div/input").send_keys(hObjValues[sObjName][get_EmailAlertsEditTable[r].find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")])
            blnUpdateReturn=true
          end
        when 2
          # - 2 = Object - Not configurable
          if addnew
            get_EmailAlertsEditTable[r].find_elements(:xpath => "./td[2]/div/select/option").each do |option|
              if option.text == hObjValues[sObjName][get_EmailAlertsEditTable[r].find_element(:xpath => "./td[1]").text.gsub("*\n", "")]
                option.click unless option.selected?
                break
              end
            end
          end
        when 4, 7, 8
          # - 4,7 = Blank Row, 8 = Text, no configurable item
          # - Do nothing, row not required
        when 3
          # - 3 = Email Template
          if !(hObjValues[sObjName][get_EmailAlertsEditTable[r].find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] == get_EmailAlertsEditTable[r].find_element(:xpath => "./td[2]/div/span/input").attribute("value"))
            get_EmailAlertsEditTable[r].find_element(:xpath => "./td[2]/div/span/input").send_keys(hObjValues[sObjName][get_EmailAlertsEditTable[r].find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")])
            blnUpdateReturn=true
          end
        when 5
          # - 5 = Recipient Type - Not a configurable item, used for Selected Recipients section
          $precedRow=get_EmailAlertsEditTable[r]
        when 6
          # - 6 = Recipents
          #-Gets current Selected Recipents list
          $aSelected=[]
          get_EmailAlertsEditTable[r].find_elements(:xpath => "./td[2]/div/table/tbody/tr/td[3]/select/option").each do |sr|
            $aSelected.push(sr.text)
          end

          #-Returns the Recipents that need to be added to the Selected List
          aAddRecipents=hObjValues[sObjName][get_EmailAlertsEditTable[r].find_element(:xpath => "./td[1]").text.gsub("*\n", "")]-$aSelected
          if aAddRecipents.size > 0
            # - Add Required Recipents
            aAddRecipents.each do |adduser|
              searchItem=""
              searchName=""

              case 
              when adduser.include?(": ")
                searchItem=adduser[0..(adduser.index(": ")-1)]
                searchItem="Public Groups" if adduser[0..(adduser.index(": ")-1)] == "Group"
                searchName=adduser[(adduser.index(": ")+2)..-1]
              when adduser == "Account Owner"
                searchItem=adduser
                searchName=adduser
              when adduser.include?("Creator")
                searchItem="Creator"
                searchName=adduser
              when adduser == "Lead or Contact Owner"
                searchItem="Related Lead or Contact Owner"
                searchName=adduser
              when adduser.include?("Owner")
                searchItem="Owner"
                searchName=adduser
              end

              if !searchItem.nil?
                $precedRow.find_elements(:xpath => "./td[2]/div/select/option").each do |option|
                    if option.text == searchItem
                      #-Recipient Type Search Option selection
                      option.click unless option.selected?
                      
                      #-Recipient 'For' textbox, to narrow down 'Available Recipients' list
                      $precedRow.find_element(:xpath => "./td[2]/div/input[@type='text' and @id='searchValue_userFilter']").clear()
                      $precedRow.find_element(:xpath => "./td[2]/div/input[@type='text' and @id='searchValue_userFilter']").send_keys(searchName)
                      $precedRow.find_element(:xpath => "./td[2]/div/input[@class='btn' and @title='Find']").click

                      #-Select and move to right, Recipient (from Avialable list)
                      get_EmailAlertsEditTable[r].find_elements(:xpath => "./td[2]/div/table/tbody/tr/td[1]/select/option").each do |option|
                        if option.text == adduser
                          option.click
                        end
                      end
                      get_EmailAlertsEditTable[r].find_element(:xpath => "./td[2]/div/table/tbody/tr/td[2]/div[2]/a").click
                    end
                end
              end
            end

            blnUpdateReturn=true
          end
          
          #-Returns the Recipents that need to be removed from the current Selected List
          aRemoveRecipents=$aSelected-hObjValues[sObjName][get_EmailAlertsEditTable[r].find_element(:xpath => "./td[1]").text.gsub("*\n", "")]
          aRemoveRecipents=aRemoveRecipents-["--None--"]
          if aRemoveRecipents.size > 0
            aRemoveRecipents.each do |removeRecipient|
              get_EmailAlertsEditTable[r].find_elements(:xpath => "./td[2]/div/table/tbody/tr/td[3]/select/option").each do |option|
                if option.text == removeRecipient
                  option.click unless option.selected?
                end
              end
              get_EmailAlertsEditTable[r].find_element(:xpath => "./td[2]/div/table/tbody/tr/td[2]/div[3]/a").click
            end
            puts "Recipents to Remove: #{aRemoveRecipents}"
            blnUpdateReturn=true
          end

        when 9
          # - 9 = Additional Emails
          if !(hObjValues[sObjName][get_EmailAlertsEditTable[r].find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] == get_EmailAlertsEditTable[r].find_element(:xpath => "./td[2]/textarea").text)
            get_EmailAlertsEditTable[r].find_element(:xpath => "./td[2]/textarea").send_keys(hObjValues[sObjName][get_EmailAlertsEditTable[r].find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")])
            blnUpdateReturn=true
          end
        when 10
          # - 10 = From Email Address
          if !(hObjValues[sObjName][get_EmailAlertsEditTable[r].find_element(:xpath => "./td[1]/label")] == get_EmailAlertsEditTable[r].find_element(:xpath => "./td[2]/div/select/option[@selected='selected']").text)
            get_EmailAlertsEditTable[r].find_elements(:xpath => "./td[2]/div/select/option").each do |option|
              if option.text == hObjValues[sObjName][get_EmailAlertsEditTable[r].find_element(:xpath => "./td[1]/label")]
                option.click unless option.selected?
                blnUpdateReturn=true
              end
            end
          end

        when 11
          # - 11 = Checkbox; Make this address the default From email address for this object's email alerts
          checkboxStatus=get_EmailAlertsEditTable[r].find_element(:xpath => "./td[2]/input").attribute("checked").nil? ? "false" : "true"
          if !(hObjValues[sObjName][get_EmailAlertsEditTable[r].find_element(:xpath => "./td[2]/label").text] == checkboxStatus)
            get_EmailAlertsEditTable[r].find_element(:xpath => "./td[2]/input").click
            blnUpdateReturn=true
          end
        end
        r+=1
      end

      return blnUpdateReturn
    end
    # -----------------------------

  end
end