# ----------------------------------------------
# - Page: Field Updates
# ----------------------------------------------

module SfdcSe
  class Driver
  	
  	# -----------------------------
  	# click_btn_FieldUpdatesContinue
  	# => Clicks the 'Continue' button on the Field Updates page
  	#
  	def click_btn_FieldUpdatesContinue
      sleep(3)
  		@driver.find_element(:xpath => "//input[@class='btn' and @title='Continue']").click
      sleep(3)
  	end
  	# -----------------------------

  	# -----------------------------
  	# click_btn_FieldUpdatesEditCancel
  	# => Clicks the 'Cancel' button on the Field Updates Edit page
  	#
  	def click_btn_FieldUpdatesEditCancel
  		@driver.find_element(:xpath => "//td[@id='bottomButtonRow']/input[@class='btn' and @title='Cancel']").click
  	end
  	# -----------------------------

    # -----------------------------
    # click_btn_FieldUpdatesEditNew
    # => Clicks the 'New' button on the Field Updates Edit page
    #
    def click_btn_FieldUpdatesEditNew
      @driver.find_element(:xpath => "//input[@class='btn' and @title='New Field Update']").click
    end
    # -----------------------------

    # -----------------------------
    # click_btn_FieldUpdatesEditSave
    # => Clicks the 'Save' button on the Field Updates Edit page
    #
    def click_btn_FieldUpdatesEditSave
      @driver.find_element(:xpath => "//td[@id='topButtonRow']/input[@class='btn' and @title='Save']").click

      sMsg=""
      a=@driver.switch_to.alert rescue "Exception happened"
      if !(a == "Exception happened")
        sMsg= "Accepting Alert: #{a.text}"
        a.accept
      end

      # - Click the 'Bread Crumb' link to return to full Email Alert List View
      @driver.find_element(:xpath => "//div[@class='ptBreadcrumb']/a").click

      return sMsg
    end
    # -----------------------------

  	# -----------------------------
    # get_FieldUpdatesViewOptions
    # => returns all the elements for the Field Updates dropdown
    #
  	def get_FieldUpdatesViewOptions
  		return @driver.find_elements(:xpath => "//select[@id='fcf' and @title='View:']/option")
  	end
  	# -----------------------------

  	# -----------------------------
    # get_FieldUpdatesEdit_IdentificationTable
    # => returns all the elements for the Field Updates Edit Identification Table
  	def get_FieldUpdatesEdit_IdentificationTable
  		return @driver.find_elements(:xpath => "//h3[contains(.,'Identification')]/../following-sibling::div[1]/table/tbody/tr")
  	end
  	# -----------------------------

  	# -----------------------------
    # get_FieldUpdatesEdit_SpecifyNewFieldValueTable
    # => returns all the elements for the Field Updates Edit Specify New Field Value Table
  	def get_FieldUpdatesEdit_SpecifyNewFieldValueTable
  		return @driver.find_elements(:xpath => "//h3[contains(.,'Specify New Field Value')]/../following-sibling::div[1]/table/tbody/tr")
  	end
  	# -----------------------------

  	# -----------------------------
    # get_FieldUpdatesTable
    # => returns all the elements for the Field Updates Table
  	def get_FieldUpdatesTable
  		return @driver.find_elements(:xpath => "//table[@class='list']/tbody/tr")
  	end
  	# -----------------------------
  	

  	# -----------------------------
    # set_EmailAlerts_View
    # => sViewName = string value of the Sharing Setting option to select
    # => Return = true or false
    # =>    true  = setting of view were successful
    # =>    false = setting of view had an error
    #
  	def set_FieldUpdates_View(sViewName)
  		blnViewSet=false
  		begin
        get_EmailAlertsViewOptions.each do |option|
  				if option.text == sViewName
  					option.click unless option.selected?
  					blnViewSet=true
  					# return blnViewSet
            break
  				end
  			end

        # - TODO: Add logic to get all rows on one page
        currentURL=@driver.current_url
        puts "Current URL: #{currentURL}"
        currentURL=@driver.current_url[0..(@drivercurrent_url.index("rowsperpage=")+12)] & "1000" if currentURL.include?("rowsperpage=")
        puts "Updated URL: #{currentURL}"
      rescue
  			puts $!
	    	puts $@
  		end
  		return blnViewSet
  	end
  	# -----------------------------

  	# -----------------------------
    # click_Edit_FieldUpdatesTable
    # => sDescriptionName = string value of the Field Updates to click Edit
    # => Return = true or false
    # =>    true = value was found and 'edit' clicked
    # =>    false =value was not found or had an error
    #
    def click_Edit_FieldUpdatesTable(sDescriptionName)
      blnEdit=false
      aDescriptionName=sDescriptionName.split("|")
      
      r=0
      while r < get_FieldUpdatesTable.length
        if get_FieldUpdatesTable[r].find_element(:xpath => "./th[1]").text == aDescriptionName[0]
          get_FieldUpdatesTable[r].find_element(:xpath => "./td[1]/a[1]").click
          if get_FieldUpdatesEdit_IdentificationTable[1].find_element(:xpath => "./td[2]/div/input").attribute("value") == aDescriptionName[1]
            blnEdit=true
            break
          else
            click_btn_FieldUpdatesEditCancel
          end
        end
        r+=1
      end

      return blnEdit
    end
    # -----------------------------
    

  	# -----------------------------
  	# get_FieldUpdates_Configuration
  	# => Return = Hash {Key= Field Name/Type, Value=Field Value}
  	#
  	def get_FieldUpdates_Configuration
  		response=Hash.new

  		# - Get 'Identification' section of the Field Update page
  		get_FieldUpdatesEdit_IdentificationTable.each_with_index do |row, idx|
  			case idx
  			when 0,1
  				# - 0=Name, 1=Unique Name
  				response[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")]=row.find_element(:xpath => "./td[2]/div/input").attribute("value")
  			when 2
  				# - 2=Description
  				response[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")]=row.find_element(:xpath => "./td[2]/textarea").text
  			when 3,4
  				# - 3=Object, 4=Field to Update
  				response[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")]=row.find_element(:xpath => "./td[2]").text
  			when 5
  				# - 5=Field Data Type
  				response[row.find_element(:xpath => "./td[1]").text.gsub("*\n", "")]=row.find_element(:xpath => "./td[2]").text
  			when 6
  				# - 6=Re-evaluate Workflow Rules after Field Change; Checkbox
  				row.find_element(:xpath => "./td[2]/input").attribute("checked").nil? ? response[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")]="false" : response[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")]=row.find_element(:xpath => "./td[2]/input").attribute("checked")
  				# response[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")]=row.find_element(:xpath => "./td[2]/input").attribute("value")
  			end
  		end

  		# - Determine the 'Specify New Field Value' section and get configuration
  		case response["Field Data Type"]
  		when "Picklist"
  			# - Picklist Options added to hash
  			get_FieldUpdatesEdit_SpecifyNewFieldValueTable.each do |row|
  				row.find_elements(:xpath => "./td[2]/ul/li").each_with_index do |radiobtns, idx|
  					case idx
  					when 0,1
              response[radiobtns.find_element(:xpath => "./label").text] = (!radiobtns.find_element(:xpath => "./input").attribute("checked").nil? ).to_s

  						# if radiobtns.find_element(:xpath => "./input").selected?
  						# 	response[row.find_element(:xpath => "./td[2]/h5").text]=radiobtns.find_element(:xpath => "./label").text
  						# end
  					when 2
              response[radiobtns.find_element(:xpath => "./div/label").text] = [(!radiobtns.find_element(:xpath => "./div/input").attribute("checked").nil?).to_s, radiobtns.find_element(:xpath => "./div/span/select/option[@selected='selected']").text]

  						# if radiobtns.find_element(:xpath => "./div/input").selected?
  						# 	response[row.find_element(:xpath => "./td[2]/h5").text]="#{radiobtns.find_element(:xpath => "./div/label").text};#{radiobtns.find_element(:xpath => "./div/span/select/option[@selected='selected']").text}"
  						# end
  					end
  				end
  			end
  		when "Record Type"
  			# - Record Type dropdrown added to hash
  			response[get_FieldUpdatesEdit_SpecifyNewFieldValueTable[1].find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")]=get_FieldUpdatesEdit_SpecifyNewFieldValueTable[1].find_element(:xpath => "./td[2]/div/select/option[@selected='selected']").text
  		when "Date/Time", "Text", "Text Area", "Date", "Currency", "Phone", "Number", "Long Text Area", "Email", "Fax"
  			# - Date Options added to hash; Text Options added to hash
  			get_FieldUpdatesEdit_SpecifyNewFieldValueTable.each do |row|
  				row.find_elements(:xpath => "./td[2]/ul/li").each_with_index do |radiobtns, idx|
  					case idx
  					when 0
              response[radiobtns.find_element(:xpath => "./label").text.gsub("*\n", "")] = (!radiobtns.find_element(:xpath => "./input").attribute("checked").nil?).to_s

  						# if radiobtns.find_element(:xpath => "./input").selected?
  						# 	response[row.find_element(:xpath => "./td[2]/h5").text]=radiobtns.find_element(:xpath => "./label").text
  						# end
  					when 1
              response[radiobtns.find_element(:xpath => "./div/label").text.gsub("*\n", "")] = [(!radiobtns.find_element(:xpath => "./div/input").attribute("checked").nil?).to_s, radiobtns.find_element(:xpath => "./div/div/div[2]/table/tbody/tr/td/div/textarea").text]

  						# if radiobtns.find_element(:xpath => "./div/input").selected?
  						# 	response[row.find_element(:xpath => "./td[2]/h5").text]="#{radiobtns.find_element(:xpath => "./div/label").text.gsub("*\n", "")};#{radiobtns.find_element(:xpath => "./div/div/div[2]/table/tbody/tr/td/div/textarea").text}"
  						# end
  					end
  				end
  			end
  		when "Checkbox"
  			get_FieldUpdatesEdit_SpecifyNewFieldValueTable.each do |row|
  				row.find_elements(:xpath => "./td[2]/ul/li").each_with_index do |radiobtns, idx|
            response[radiobtns.find_element(:xpath => "./label").text.gsub("*\n", "")] = (!radiobtns.find_element(:xpath => "./input").attribute("checked").nil?).to_s

  					# response[row.find_element(:xpath => "./td[2]/h5").text]=radiobtns.find_element(:xpath => "./label").text.gsub("*\n", "") if radiobtns.find_element(:xpath => "./input").attribute("checked")
  				end
  			end
      when "Lookup"
        get_FieldUpdatesEdit_SpecifyNewFieldValueTable.each_with_index do |row, idx|
          case idx
          when 0
            # - Do nothing, blank row
          when 1
            # - Text Box (Lookup) Field
            response[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] = row.find_element(:xpath => "./td[2]/div/span/input").attribute("value")
          when 2
            # - Checkbox
            response[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] = (!row.find_element(:xpath => "./td[2]/input").attribute("checked").nil?).to_s
         end
       end
  		end

  		return response
  	end
  	# -----------------------------

    # -----------------------------
    # set_FieldUpdates_Configuration
    # => sObjName = string value of the object to set
    # => hObjValues = Values to set, Hash {Field, Value}
    # => addnew = Boolean, defaults to false unless true is passed
    #     - Set to true to create a new Email Alert (rather then adjusting the configuration of an existing one)
    # => return = true/false
    #     - True = Configuration was updated
    #     - False = Configration was NOT updated
    #
    def set_FieldUpdates_Configuration(sObjName, hObjValues, addnew=false)
      addnew=false unless addnew==true
      blnUpdateReturn=false
      r=0
      @driver.manage.timeouts.implicit_wait = 0

      # - Get 'Identification' section of the Field Update page
      while r < get_FieldUpdatesEdit_IdentificationTable.length
      # get_FieldUpdatesEdit_IdentificationTable.each_with_index do |row, idx|
        case r
        when 0,1
          # - 0=Name, 1=Unique Name
          if !(hObjValues[sObjName][get_FieldUpdatesEdit_IdentificationTable[r].find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] == get_FieldUpdatesEdit_IdentificationTable[r].find_element(:xpath => "./td[2]/div/input").attribute("value"))
            get_FieldUpdatesEdit_IdentificationTable[r].find_element(:xpath => "./td[2]/div/input").clear()
            get_FieldUpdatesEdit_IdentificationTable[r].find_element(:xpath => "./td[2]/div/input").send_keys(hObjValues[sObjName][get_FieldUpdatesEdit_IdentificationTable[r].find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")])
            puts "Updated Field: #{get_FieldUpdatesEdit_IdentificationTable[r].find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")}"
            blnUpdateReturn=true
          end

          # response[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")]=row.find_element(:xpath => "./td[2]/div/input").attribute("value")
        when 2
          # - 2=Description
          if !(hObjValues[sObjName][get_FieldUpdatesEdit_IdentificationTable[r].find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] == get_FieldUpdatesEdit_IdentificationTable[r].find_element(:xpath => "./td[2]/textarea").text)
            get_FieldUpdatesEdit_IdentificationTable[r].find_element(:xpath => "./td[2]/textarea").clear()
            get_FieldUpdatesEdit_IdentificationTable[r].find_element(:xpath => "./td[2]/textarea").send_keys(hObjValues[sObjName][get_FieldUpdatesEdit_IdentificationTable[r].find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")])
            puts "Updated Field: #{get_FieldUpdatesEdit_IdentificationTable[r].find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")}"
            blnUpdateReturn=true
          end

          # response[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")]=row.find_element(:xpath => "./td[2]/textarea").text
        when 3,4
          # - 3=Object, 4=Field to Update
          # - Object
          if addnew
            if get_FieldUpdatesEdit_IdentificationTable[r].find_elements(:xpath => "./td[1]//*").size == 0
              # - Row has multiple dropdown selections
              aFieldToUpdate=hObjValues[sObjName][get_FieldUpdatesEdit_IdentificationTable[r].find_element(:xpath => "./td[1]").text.gsub("*\n", "")].split(": ")
              aFieldToUpdate.each_with_index do |aFieldSelection, idx|
                if idx == 0
                  aDropdownLists=get_FieldUpdatesEdit_IdentificationTable[r].find_elements(:xpath => "./td[2]/div/select[#{idx+1}]/option")
                else
                  aDropdownLists=get_FieldUpdatesEdit_IdentificationTable[r].find_elements(:xpath => "./td[2]/div/select[#{idx+1}]/optgroup/option")
                end
                aDropdownLists.each do |option|
                  if option.text == aFieldSelection
                    option.click unless option.selected?
                    sleep(5)
                    puts "Updated Field: #{aFieldSelection}"
                    blnUpdateReturn=true
                    break
                  end
                end
              end
            else
              # - Row has single dropdown seletion
              get_FieldUpdatesEdit_IdentificationTable[r].find_elements(:xpath => "./td[2]/div/select/option").each do |option|
                if option.text == hObjValues[sObjName][get_FieldUpdatesEdit_IdentificationTable[r].find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")]
                  option.click unless option.selected?
                  sleep(5)
                  puts "Updated Field: #{get_FieldUpdatesEdit_IdentificationTable[r].find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")}"
                  blnUpdateReturn=true
                  break
                end
              end
            end
          end

          # response[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")]=row.find_element(:xpath => "./td[2]").text
        when 5
          # - 5=Field Data Type
          $sFldDataType=get_FieldUpdatesEdit_IdentificationTable[r].find_element(:xpath => "./td[2]").text

          # response[row.find_element(:xpath => "./td[1]").text.gsub("*\n", "")]=row.find_element(:xpath => "./td[2]").text
        when 6
          # - 6=Re-evaluate Workflow Rules after Field Change; Checkbox
          checkboxStatus=get_FieldUpdatesEdit_IdentificationTable[r].find_element(:xpath => "./td[2]/input").attribute("checked").nil? ? "false" : "true"
          if !(hObjValues[sObjName][get_FieldUpdatesEdit_IdentificationTable[r].find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] == checkboxStatus)
            get_FieldUpdatesEdit_IdentificationTable[r].find_element(:xpath => "./td[2]/input").click
            puts "Updated Field: #{get_FieldUpdatesEdit_IdentificationTable[r].find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")}"
            blnUpdateReturn=true
          end

          # row.find_element(:xpath => "./td[2]/input").attribute("checked").nil? ? response[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")]="false" : response[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")]=row.find_element(:xpath => "./td[2]/input").attribute("checked")
          # response[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")]=row.find_element(:xpath => "./td[2]/input").attribute("value")
        end

        r+=1
      end

      # - Determine the 'Specify New Field Value' section and set configuration
      case $sFldDataType
      when "Picklist"
        # - Picklist Options added to hash
        get_FieldUpdatesEdit_SpecifyNewFieldValueTable.each do |row|
          row.find_elements(:xpath => "./td[2]/ul/li").each_with_index do |radiobtns, idx|
            case idx
            when 0,1
              if !(hObjValues[sObjName][radiobtns.find_element(:xpath => "./label").text.gsub("*\n", "")] == (!radiobtns.find_element(:xpath => "./input").attribute("checked").nil?).to_s)
                radiobtns.find_element(:xpath => "./input").click
                puts "Updated Field: #{radiobtns.find_element(:xpath => "./label").text.gsub("*\n", "")}"
                blnUpdateReturn=true
              end

              # response[radiobtns.find_element(:xpath => "./label").text] = (!radiobtns.find_element(:xpath => "./input").attribute("checked").nil? ).to_s

              # if radiobtns.find_element(:xpath => "./input").selected?
              #   response[row.find_element(:xpath => "./td[2]/h5").text]=radiobtns.find_element(:xpath => "./label").text
              # end
            when 2
              if !(hObjValues[sObjName][radiobtns.find_element(:xpath => "./div/label").text.gsub("*\n", "")][0] == (!radiobtns.find_element(:xpath => "./div/input").attribute("checked").nil?).to_s)
                radiobtns.find_element(:xpath => "./div/input").click
                radiobtns.find_elements(:xpath => "./div/span/select/option").each do |option|
                  if option.text == hObjValues[sObjName][radiobtns.find_element(:xpath => "./div/label").text.gsub("*\n", "")][1]
                    puts "Updated Dropdown Value To: #{option.text}" unless option.selected?
                    option.click unless option.selected?
                  end
                end
                puts "Updated Field: #{radiobtns.find_element(:xpath => "./div/label").text.gsub("*\n", "")}"
                blnUpdateReturn=true
              end

              # response[radiobtns.find_element(:xpath => "./div/label").text] = [(!radiobtns.find_element(:xpath => "./div/input").attribute("checked").nil?).to_s, radiobtns.find_element(:xpath => "./div/span/select/option[@selected='selected']").text]

              # if radiobtns.find_element(:xpath => "./div/input").selected?
              #   response[row.find_element(:xpath => "./td[2]/h5").text]="#{radiobtns.find_element(:xpath => "./div/label").text};#{radiobtns.find_element(:xpath => "./div/span/select/option[@selected='selected']").text}"
              # end
            end
          end
        end
      when "Record Type"
        # - Record Type dropdrown added to hash
        if !(hObjValues[sObjName][get_FieldUpdatesEdit_SpecifyNewFieldValueTable[1].find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] == get_FieldUpdatesEdit_SpecifyNewFieldValueTable[1].find_element(:xpath => "./td[2]/div/select/option[@selected='selected']").text)
          get_FieldUpdatesEdit_SpecifyNewFieldValueTable[1].find_elements(:xpath => "./td[2]/div/select/option").each do |option|
            if option.text == hObjValues[sObjName][get_FieldUpdatesEdit_SpecifyNewFieldValueTable[1].find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")]
              puts "Updated Dropdown Value To: #{option.text}" unless option.selected?
              option.click unless option.selected?
              blnUpdateReturn=true
            end
          end
        end

        # response[get_FieldUpdatesEdit_SpecifyNewFieldValueTable[1].find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")]=get_FieldUpdatesEdit_SpecifyNewFieldValueTable[1].find_element(:xpath => "./td[2]/div/select/option[@selected='selected']").text
      when "Date/Time", "Text", "Text Area", "Date", "Currency", "Phone", "Number", "Long Text Area", "Email", "Fax"
        # - Date Options added to hash; Text Options added to hash
        get_FieldUpdatesEdit_SpecifyNewFieldValueTable.each do |row|
          row.find_elements(:xpath => "./td[2]/ul/li").each_with_index do |radiobtns, idx|
            case idx
            when 0
              if !(hObjValues[sObjName][radiobtns.find_element(:xpath => "./label").text.gsub("*\n", "")] == (!radiobtns.find_element(:xpath => "./input").attribute("checked").nil?).to_s)
                radiobtns.find_element(:xpath => "./input").click
                puts "Updated Field: #{radiobtns.find_element(:xpath => "./label").text.gsub("*\n", "")}"
                blnUpdateReturn=true
              end

              # response[radiobtns.find_element(:xpath => "./label").text.gsub("*\n", "")] = (!radiobtns.find_element(:xpath => "./input").attribute("checked").nil?).to_s

              # if radiobtns.find_element(:xpath => "./input").selected?
              #   response[row.find_element(:xpath => "./td[2]/h5").text]=radiobtns.find_element(:xpath => "./label").text
              # end
            when 1
              #- Validate Radio Button and then Dropdown Value
              if !(hObjValues[sObjName][radiobtns.find_element(:xpath => "./div/label").text.gsub("*\n", "")][0] == (!radiobtns.find_element(:xpath => "./div/input").attribute("checked").nil?).to_s)
                radiobtns.find_element(:xpath => "./div/input").click
                puts "Upated Field: #{radiobtns.find_element(:xpath => "./div/label").text.gsub("*\n", "")}"
                blnUpdateReturn=true
              end
              if !radiobtns.find_element(:xpath => "./div/input").attribute("checked").nil?
                puts "Formula Value - JSON: #{hObjValues[sObjName][radiobtns.find_element(:xpath => "./div/label").text.gsub("*\n", "")][1]}"
                if !(hObjValues[sObjName][radiobtns.find_element(:xpath => "./div/label").text.gsub("*\n", "")][1] == radiobtns.find_element(:xpath => "./div/div/div[2]/table/tbody/tr/td/div/textarea").text)
                  radiobtns.find_element(:xpath => "./div/div/div[2]/table/tbody/tr/td/div/textarea").clear()
                  radiobtns.find_element(:xpath => "./div/div/div[2]/table/tbody/tr/td/div/textarea").send_keys(hObjValues[sObjName][radiobtns.find_element(:xpath => "./div/label").text.gsub("*\n", "")][1])
                  puts "Updated Text/Formula To : #{hObjValues[sObjName][radiobtns.find_element(:xpath => "./div/label").text.gsub("*\n", "")][1]}"
                  blnUpdateReturn=true
                end
              end

              # response[radiobtns.find_element(:xpath => "./div/label").text.gsub("*\n", "")] = [(!radiobtns.find_element(:xpath => "./div/input").attribute("checked").nil?).to_s, radiobtns.find_element(:xpath => "./div/div/div[2]/table/tbody/tr/td/div/textarea").text]

              # if radiobtns.find_element(:xpath => "./div/input").selected?
              #   response[row.find_element(:xpath => "./td[2]/h5").text]="#{radiobtns.find_element(:xpath => "./div/label").text.gsub("*\n", "")};#{radiobtns.find_element(:xpath => "./div/div/div[2]/table/tbody/tr/td/div/textarea").text}"
              # end
            end
          end
        end
      when "Checkbox"
        get_FieldUpdatesEdit_SpecifyNewFieldValueTable.each do |row|
          row.find_elements(:xpath => "./td[2]/ul/li").each do |radiobtns|
            if !(hObjValues[sObjName][radiobtns.find_element(:xpath => "./label").text.gsub("*\n", "")] == (!radiobtns.find_element(:xpath => "./input").attribute("checked").nil?).to_s)
              radiobtns.find_element(:xpath => "./input").attribute("checked").click
              puts "Updated Field: #{radiobtns.find_element(:xpath => "./label").text.gsub("*\n", "")}"
              blnUpdateReturn=true
            end

            # response[radiobtns.find_element(:xpath => "./label").text.gsub("*\n", "")] = (!radiobtns.find_element(:xpath => "./input").attribute("checked").nil?).to_s

            # response[row.find_element(:xpath => "./td[2]/h5").text]=radiobtns.find_element(:xpath => "./label").text.gsub("*\n", "") if radiobtns.find_element(:xpath => "./input").attribute("checked")
          end
        end
      when "Lookup"
        get_FieldUpdatesEdit_SpecifyNewFieldValueTable.each_with_index do |row, idx|
          case idx
          when 0
            # - Do nothing, blank row
          when 1
            # - Text Box (Lookup) Field
            # -########################################
            if !(hObjValues[sObjName][row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] == row.find_element(:xpath => "./td[2]/div/span/input").attribute("value"))
              row.find_element(:xpath => "./td[2]/div/span/input").clear()
              row.find_element(:xpath => "./td[2]/div/span/input").send_keys(hObjValues[sObjName][row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")])
              puts "Updated Field: #{row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")}"
              blnUpdateReturn=true
            end

            # response[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] = row.find_element(:xpath => "./td[2]/div/span/input").attribute("value")
          when 2
            # - Checkbox
            if !(hObjValues[sObjName][row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] == (!row.find_element(:xpath => "./td[2]/input").attribute("checked").nil?).to_s)
              row.find_element(:xpath => "./td[2]/input").click
              puts "Update Field: #{row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")}"
              blnUpdateReturn=true
            end

            # response[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] = (!row.find_element(:xpath => "./td[2]/input").attribute("checked").nil?).to_s
         end
        end
      end

      # return response
      @driver.manage.timeouts.implicit_wait = @implicitWait
      return blnUpdateReturn
    end
    # -----------------------------

  end
end