# ----------------------------------------------
# - Page: Home Page Layouts
# -- Body of the page
# ----------------------------------------------

module SfdcSe
  class Driver
  	
    # -----------------------------
    # click_Btn_HomePageLayouts_PageLayoutAssignment
    # => Clicks the 'Home Page Layouts' button 
    #
  	def click_Btn_HomePageLayouts_PageLayoutAssignment
  		@driver.find_element(:xpath => "//input[@title='Page Layout Assignment']").click
      sleep(3)
    end

    # -----------------------------
    # click_Btn_HomePageLayouts_EditAssignment
    #
    def click_Btn_HomePageLayouts_EditAssignment
      @driver.find_element(:xpath => "//input[@title = 'Edit Assignment']").click
      sleep(3)
    end

    # -----------------------------
    # click_Btn_HomePageLayouts_save
    #
    def click_Btn_HomePageLayouts_save
      @driver.find_element(:xpath => "//td[@id = 'topButtonRow']/input[@title='Save']").click
      return @driver.find_element(:xpath => "//input[@title = 'Edit Assignment']").displayed?
    end

    # -----------------------------
    # get_elements_HomePageLayouts_Profiles_table
    #
    def get_elements_HomePageLayouts_Profiles_table
      return @driver.find_elements(:xpath => "//table[@class='detailList']/tbody/tr")
    end

    # -----------------------------
    # get_HomePageLayouts_Profile_Assignments
    # => Returns a hash; Key = Profile Name, Value = Page Layout Assignment
    #
    def get_HomePageLayouts_Profile_Assignments
      hProfiles=Hash.new
      get_elements_HomePageLayouts_Profiles_table.each do |row|
        hProfiles[row.find_element(:xpath => "./td[1]").text] = row.find_element(:xpath => "./td[2]").text
      end
      return hProfiles
    end

    # -----------------------------
    # set_HomePageLayout_Profile_Assignments
    # => hProfileAssignments = Hash of the profiles and assignments
    # =>    key = Profile
    # =>    value = assignment
    # => Return = true or false
    # =>    true  = setting of all assignments were successful
    # =>    false = setting had an error, or no vales were changed
    #
    def set_HomePageLayout_Profile_Assignments(hProfileAssignments)
      blnChangedValue=false
      begin
        get_elements_HomePageLayouts_Profiles_table.each do |row|
          strProfile=row.find_element(:xpath => "./td[1]").text
          if strProfile[0] == "*"
            strProfile=strProfile[1..-1]
          end
          
          if hProfileAssignments.has_key? (strProfile)
            # check if current value is already set to assignment, if not set
            options=row.find_elements(:xpath => "./td[2]/div/select/option")

            options.each do |option|
              if option.selected?
                $strCurrentlySelected = option.text
              end
            end

            if hProfileAssignments[strProfile] != $strCurrentlySelected
              options.each do |option|
                if option.text == hProfileAssignments[strProfile]
                  option.click
                  blnChangedValue=true
                end
              end
            end
          end
        end
      rescue
        puts $!
        puts $@
        blnChangedValue = false
      end
      return blnChangedValue
    end
    # -----------------------------

    # -----------------------------
    # set_HomePageLayout_Profile_Assignments2
    # => sProfile = String for profile to check/set
    # => sAssignment = String for Assigment value
    # => Return = true or false
    # =>    true = setting of value was successfull
    # =>    false = setting had an error or values was already set correctly
    def set_HomePageLayout_Profile_Assignments(sProfile, sAssignment)
      blnReturn=false 
      get_elements_HomePageLayouts_Profiles_table.each do |row|
        if row.find_element(:xpath => "./td[1]").text.gsub("*\n", "") == sProfile
          if !(row.find_element(:xpath => "./td[2]/div/select/option[@selected='selected']").text == sAssignment)
            row.find_elements(:xpath => "./td[2]/div/select/option").each do |option|
              if option.text == sAssignment
                option.click
                blnReturn=true
                break
              end
            end
          end
          break
        end
      end
      return blnReturn
    end
    # -----------------------------

  end
end