# ----------------------------------------------
# - Page: Profiles
# ----------------------------------------------

module SfdcSe
  class Driver
  	
  	# -----------------------------
    # get_ProfileViewOptions
    # => returns all the elements for the Profiles View dropdown
  	def get_ProfileViewOptions
  		return @driver.find_elements(:xpath => "//form/div[1]/div/select/option")
  	end
  	# -----------------------------

  	# -----------------------------
    # get_elements_Profiles_table
    # => returns all the elements for the Profiles table
  	def get_elements_Profiles_table
      return @driver.find_elements(:xpath => "//table[@class='x-grid3-row-table']/tbody/tr")
    end
    # -----------------------------

    # -----------------------------
    # get_Profiles_AdministrativePermissions_table
    # => returns all the elements for the Profiles Administravite Permissions table
    def get_Profiles_AdministrativePermissions_table
    	return @driver.find_elements(:xpath => "//h3[contains(.,'Administrative Permissions')]/../following-sibling::div[1]/table/tbody/tr")
	end
	# -----------------------------

	# -----------------------------
    # get_Profiles_GeneralUserPermissions_table
    # => returns all the elements for the Profiles General User Permissions table
    def get_Profiles_GeneralUserPermissions_table
    	return @driver.find_elements(:xpath => "//h3[contains(.,'General User Permissions')]/../following-sibling::div[1]/table/tbody/tr")
	end
	# -----------------------------

	# -----------------------------
    # get_Profiles_StandardObjectPermissions_table
    # => returns all the elements for the Profiles Standard Object Permissions table
    def get_Profiles_StandardObjectPermissions_table
    	return @driver.find_elements(:xpath => "//h3[contains(.,'Standard Object Permissions')]/../following-sibling::div[1]/table/tbody/tr")
	end
	# -----------------------------

  # -----------------------------
    # get_Profiles_CusomObjectPermissions_table
    # => returns all the elements for the Profiles Custom Object Permissions table
    def get_Profiles_CustomObjectPermissions_table
      return @driver.find_elements(:xpath => "//h3[contains(.,'Custom Object Permissions')]/../following-sibling::div[1]/table/tbody/tr")
  end
  # -----------------------------
	
	# -----------------------------
    # get_Profiles_TabSettings_table
    # => returns all the elements for the Profiles Tab Settings table
    def get_Profiles_TabSettings_table
    	if !@driver.find_elements(:xpath => "//h3[contains(.,'Tab Settings')]").nil?
	    	@aStandardTable=@driver.find_elements(:xpath => "//h3[contains(.,'Tab Settings')]/../following-sibling::div[1]/table/tbody/tr")
	    	@aCustomTable=@driver.find_elements(:xpath => "//h3[contains(.,'Tab Settings')]/../following-sibling::div[2]/table/tbody/tr")
	    	@aStandardTable.push *@aCustomTable
	    	return @aStandardTable
	    end
    end
	# -----------------------------

  # -----------------------------
  # get_Profiles_CustomProfile_CheckboxValue
  # => Returns true/false
  #     True = Custom Profile Checkbox is checked
  #     False = Custom Profile Checkbox is NOT checked
  def get_Profiles_CustomProfile_CheckboxValue
    return @driver.find_element(:xpath => "//td[contains(.,'Custom Profile')]/following-sibling::td/img").attribute("title")=='Checked' ? true : false
  end
  # -----------------------------

  # -----------------------------
    # get_Profiles_ApexClassAccess_table
    # => returns all the elements for the Profiles Apex Class Access table
    def get_Profiles_ApexClassAccess_table
      return @driver.find_elements(:xpath => "//h3[contains(.,'Enabled Apex Class Access')]/../../../../../following-sibling::div[1]/table/tbody/tr")
  end
  # -----------------------------

  # -----------------------------
    # get_Profiles_VisualforcePageAccess_table
    # => returns all the elements for the Profiles Visualforce Page Access table
    def get_Profiles_VisualforcePageAccess_table
      return @driver.find_elements(:xpath => "//h3[contains(.,'Enabled Visualforce Page Access')]/../../../../../following-sibling::div[1]/table/tbody/tr")
  end
  # -----------------------------

  # -----------------------------
    # get_Profiles_ApexClassAccess_AvailableSelect
    # => returns all the options for the Availalble Apex Classes
    def get_Profiles_ApexClassAccess_AvailableSelect
      return @driver.find_elements(:xpath => "//select[@id='duel_select_0']/option")
  end
  # -----------------------------

  # -----------------------------
    # get_Profile_VisualforcePageAccess_EnabledSelect
    # => returns all the options for the Availalble Apex Classes
    def get_Profile_VisualforcePageAccess_EnabledSelect
      return @driver.find_elements(:xpath => "//select[@id='duel_select_1']/option")
  end
  # -----------------------------


  # -----------------------------
  # click_btn_Profiles_Edit
  def click_btn_Profiles_Edit
    @driver.find_element(:xpath => "//input[@class='btn' and @title='Edit']").click
  end
  # -----------------------------

  # -----------------------------
  # click_btn_Profiles_Save
  def click_btn_Profiles_Save
    @driver.find_element(:xpath => "//input[@class='btn' and @title='Save']").click

    sMsg=""
    a=@driver.switch_to.alert rescue "Exception happened"
    if !(a == "Exception happened")
      sMsg= "Accepting Alert: #{a.text}"
      a.accept
    end

    return sMsg
  end
  # -----------------------------

  # -----------------------------
  # click_btn_Profiles_Cancel
  def click_btn_Profiles_Cancel
    @driver.find_element(:xpath => "//input[@class='btn' and @title='Cancel']").click
  end
  # -----------------------------

# -----------------------------
  # click_btn_Profiles_ApexClassAccess_Add
  def click_btn_Profiles_ApexClassAccess_Add
    @driver.find_element(:xpath => "//img[@class='rightArrowIcon' and @title='Add']").click
  end
  # -----------------------------

  # -----------------------------
  # click_Profiles_breadcrumb
  # => clicks the 'Back to List: Profiles' Breadcrumb link
	def click_Profiles_breadcrumb
    @driver.find_element(:xpath => "//div[@class='ptBreadcrumb']/a").click
    @wait.until{@driver.find_element(:xpath => "//input[@class='btn' and @title='New Profile']")}
  end
  # -----------------------------

  # -----------------------------
  # click_Profiles_ApexClassAccess_Edit
  # => clicks the 'edit' button within the Apex Class Access section
  def click_Profiles_ApexClassAccess_Edit
    @driver.find_element(:xpath => "//h3[contains(.,'Enabled Apex Class Access')]/../following-sibling::td[1]/input[@class='btn' and @title='Edit']").click
    # @driver.find_element(:xpath => "//div[@class='ptBreadcrumb']/a").click
    # @wait.until{@driver.find_element(:xpath => "//input[@class='btn' and @title='New Profile']")}
  end
  # -----------------------------

  # -----------------------------
  # click_Profiles_VisualforcePageAccess_Edit
  # => clicks the 'edit' button within the Visualforce Page Access section
  def click_Profiles_VisualforcePageAccess_Edit
    @driver.find_element(:xpath => "//h3[contains(.,'Enabled Visualforce Page Access')]/../following-sibling::td[1]/input[@class='btn' and @title='Edit']").click
  end
  # -----------------------------

  # -----------------------------
  # click_btn_Profiles_ApexClassAccess_Save
  def click_btn_Profiles_ApexClassAccess_Save
    @driver.find_element(:xpath => "//input[@class='btn' and @title='Save']").click
  end
  # -----------------------------

  # -----------------------------
  # click_btn_Profiles_ApexClassAccess_Cancel
  def click_btn_Profiles_ApexClassAccess_Cancel
    @driver.find_element(:xpath => "//input[@class='btn' and @title='Cancel']").click
  end
  # -----------------------------

	# -----------------------------
  # set_Profile_View
  # => sViewName = string value of the view name to select
  # => Return = true or false
  # =>    true  = setting of view were successful
  # =>    false = setting of view had an error
  #
	def set_Profile_View(sViewName)
		blnViewSet=false
		begin
			get_ProfileViewOptions.each do |option|
				if option.text == sViewName
					option.click unless option.selected?
					blnViewSet=true
					return blnViewSet
				end
			end
		rescue
			puts $!
      puts $@
		end
		return blnViewSet
	end
	# -----------------------------

	# -----------------------------
	# select_Profile
	# => sProfileName = String value of the profile name to select
	# => Return = true or false
	# =>  	true = Profile successfully selected
	# =>  	false = Profile selection had an error
	def select_Profile(sProfileName)
		blnValue=false
		begin
			get_elements_Profiles_table.each do |row|
				tableProfile=row.find_element(:xpath => "./td[4]").text
				if tableProfile==sProfileName
					row.find_element(:xpath => "./td[4]/div/a").click
					blnValue=true
					return blnValue
				end
			end
		rescue
        puts $!
        puts $@
        blnValue = false
		end
		return blnValue
	end

  	# -----------------------------
    # get_Profiles_AdministrativePermissions
    # => Returns a hash; Key = Permission Name, Value = Checked/Unchecked
    #
  	def get_Profiles_AdministrativePermissions
  		begin
  			@aPAP=Hash.new
        if get_Profiles_CustomProfile_CheckboxValue
    			get_Profiles_AdministrativePermissions_table.each do |i|
    				@aPAP[i.find_element(:xpath => "./td[1]").text]=i.find_element(:xpath => "./td[2]/img").attribute("alt")
    				@aPAP[i.find_element(:xpath => "./td[3]").text]=i.find_element(:xpath => "./td[4]/img").attribute("alt") unless i.find_element(:xpath => "./td[3]").attribute("class") == "labelCol last empty"
    			end
        end
  			return @aPAP
  		rescue
  			puts $!
	      puts $@
  		end
  	end
  	# -----------------------------

    # -----------------------------
    # set_Profiles_AdministrativePermissions
    # => hValues = an input Hash of the values to set per profile
    # => Returns true/false
    #
    def set_Profiles_AdministrativePermissions(hValues)
      @driver.manage.timeouts.implicit_wait = 0
      blnReturn=false

      get_Profiles_AdministrativePermissions_table.each do |i|
        # - Left hand column
        if i.find_elements(:xpath => "./td[2]/img").size == 0
          sOrgSetting = i.find_element(:xpath => "./td[2]/input").selected? ? "Checked" : "Not Checked"
          if !(sOrgSetting==hValues[i.find_element(:xpath => "./td[1]").text.gsub("*\n", "")])
            i.find_element(:xpath => "./td[2]/input").click
            blnReturn=true
          end
        end

        # - Right hand column
        if i.find_elements(:xpath => "./td[4]/img").size == 0 and i.find_element(:xpath => "./td[3]").attribute("class") != "labelCol last empty"
          sOrgSetting = i.find_element(:xpath => "./td[4]/input").selected? ? "Checked" : "Not Checked"
          if !(sOrgSetting==hValues[i.find_element(:xpath => "./td[3]").text.gsub("*\n", "")])
            i.find_element(:xpath => "./td[4]/input").click
            blnReturn=true
          end
        end

      end

      @driver.manage.timeouts.implicit_wait = @implicitWait

      return blnReturn
    end
    # -----------------------------

  	# -----------------------------
    # get_Profiles_GeneralUserPermissions
    # => Returns a hash; Key = Permission Name, Value = Checked/Unchecked
    #
  	def get_Profiles_GeneralUserPermissions
  		begin
  			@aConfig=Hash.new
        if get_Profiles_CustomProfile_CheckboxValue
    			get_Profiles_GeneralUserPermissions_table.each do |row|
    				@aConfig[row.find_element(:xpath => "./td[1]").text]=row.find_element(:xpath => "./td[2]/img").attribute("alt")
    				@aConfig[row.find_element(:xpath => "./td[3]").text]=row.find_element(:xpath => "./td[4]/img").attribute("alt") unless row.find_element(:xpath => "./td[3]").attribute("class") == "labelCol last empty"
    			end
        end
  			return @aConfig
  		rescue
  			puts $!
	      puts $@
  		end
  	end
  	# -----------------------------

    # -----------------------------
    # set_Profiles_GeneralUserPermissions
    # => Returns a hash; Key = Permission Name, Value = Checked/Unchecked
    #
    def set_Profiles_GeneralUserPermissions(hValues)
      @driver.manage.timeouts.implicit_wait = 0
      blnReturn=false

      get_Profiles_GeneralUserPermissions_table.each do |row|

        # - Left Hand Column
        if row.find_elements(:xpath => "./td[2]/img").size == 0
          sOrgSetting = row.find_element(:xpath => "./td[2]/input").selected? ? "Checked" : "Not Checked"
          if !(sOrgSetting==hValues[row.find_element(:xpath => "./td[1]").text.gsub("*\n", "")])
            row.find_element(:xpath => "./td[2]/input").click
            blnReturn=true
          end
        end

        # - Right Hand Column
        if row.find_elements(:xpath => "./td[4]/img").size == 0 and row.find_element(:xpath => "./td[3]").attribute("class") != "labelCol last empty"
          sOrgSetting = row.find_element(:xpath => "./td[4]/input").selected? ? "Checked" : "Not Checked"
          if !(sOrgSetting==hValues[row.find_element(:xpath => "./td[3]").text.gsub("*\n", "")])
            row.find_element(:xpath => "./td[4]/input").click
            blnReturn=true
          end
        end
      end

      # begin
      #   @aConfig=Hash.new
      #   #-TODO: Check if profile is CustomProfile (if not return blank hash)
      #   if get_Profiles_CustomProfile_CheckboxValue
      #     get_Profiles_GeneralUserPermissions_table.each do |row|
      #       @aConfig[row.find_element(:xpath => "./td[1]").text]=row.find_element(:xpath => "./td[2]/img").attribute("alt")
      #       @aConfig[row.find_element(:xpath => "./td[3]").text]=row.find_element(:xpath => "./td[4]/img").attribute("alt") unless row.find_element(:xpath => "./td[3]").attribute("class") == "labelCol last empty"
      #     end
      #   end
      #   return @aConfig
      # rescue
      #   puts $!
      #   puts $@
      # end

      @driver.manage.timeouts.implicit_wait = @implicitWait

      return blnReturn
    end
    # -----------------------------

  	# -----------------------------
    # get_Profiles_TabSettings
    # => Returns a hash; Key = Tab Name, Value = Default On; Default Off; Tab Hidden
    #
  	def get_Profiles_TabSettings
  		begin
  			@hConfig=Hash.new
  			if !get_Profiles_TabSettings_table.nil?
	  			get_Profiles_TabSettings_table.each do |row|
	  				next if row.attribute("class") == "detailRow"
	  				@hConfig[row.find_element(:xpath => "./td[1]").text]=row.find_element(:xpath => "./td[2]").text
	  				@hConfig[row.find_element(:xpath => "./td[3]").text]=row.find_element(:xpath => "./td[4]").text unless row.find_element(:xpath => "./td[3]").attribute("class") == "labelCol last empty"
	  			end
	  			return @hConfig
	  		end
  		rescue
  			puts $!
	      puts $@
  		end
  	end
  	# -----------------------------

    # -----------------------------
    # set_Profiles_TabSettings
    # => hProfileValues = Hash of the values to be set for the indicated Profile/Section
    # => Returns true/false
    #
    def set_Profiles_TabSettings(hProfileValues)
      blnReturn=false
      begin
        if !get_Profiles_TabSettings_table.nil?
          get_Profiles_TabSettings_table.each do |row|
            next if row.attribute("class") == "detailRow"

            if row.find_elements(:xpath => "./td[2]//*").size > 0
              if !(row.find_element(:xpath => "./td[2]/div/select/option[@selected='selected']").text == hProfileValues[row.find_element(:xpath => "./td[1]").text.gsub("*\n", "")])
                row.find_elements(:xpath => "./td[2]/div/select/option").each do |option|
                  if option.text == hProfileValues[row.find_element(:xpath => "./td[1]").text.gsub("*\n", "")]
                    option.click
                    blnReturn=true
                  end
                end
              end
            end

            if (row.find_element(:xpath => "./td[3]").attribute("class") != "labelCol last empty") and (row.find_elements(:xpath => "./td[4]//*").size > 0)
              if !(row.find_element(:xpath => "./td[4]/div/select/option[@selected='selected']").text == hProfileValues[row.find_element(:xpath => "./td[3]").text.gsub("*\n", "")])
                row.find_elements(:xpath => "./td[4]/div/select/option").each do |option|
                  if option.text == hProfileValues[row.find_element(:xpath => "./td[3]").text.gsub("*\n", "")]
                    option.click
                    blnReturn=true
                  end
                end
              end
            end
          end
          return blnReturn
        end
      rescue
        puts $!
        puts $@
      end
    end
    # -----------------------------
  	
  	# -----------------------------
    # get_Profiles_StandardObjectPermissions
    # => Returns an Nested Hash; {Object Name =>{Key = Header Name, Value = Checked/Unchecked}}
    #
  	def get_Profiles_StandardObjectPermissions
  		@driver.manage.timeouts.implicit_wait = 0
      begin
  			@aSOP_Headers=[]
  			response_hash = Hash.new {|h,k| h[k] = Hash.new(&h.default_proc) }
  			
        if get_Profiles_CustomProfile_CheckboxValue
    			get_Profiles_StandardObjectPermissions_table.each_with_index do |row, index|
    				if index == 0
    					row.find_elements(:xpath => "./td[2]/table/tbody/tr[2]/th").each do |header|
    						@aSOP_Headers.push(header.text.strip! || header.text)
    					end
    				else
  	  				# -- Left Column of Table
              $tempObjectName_Left=row.find_element(:xpath => "./th[1]").text
  	  				row.find_elements(:xpath => "./td[1]/table/tbody/tr/td").each_with_index do |hv, idx|
  	  					response_hash[$tempObjectName_Left][@aSOP_Headers[idx]]=hv.find_element(:xpath => "./img").attribute("alt") unless hv.find_elements(:xpath => ".//*").size == 0
  	  				end
  	  				
  	  				# -- Right Column of Table
              if row.find_element(:xpath => "./td[2]").attribute("class") != "labelCol last empty"
                $tempObjectName_Right=row.find_element(:xpath => "./th[2]").text
                row.find_elements(:xpath => "./td[2]/table/tbody/tr/td").each_with_index do |hv, idx|
                  if hv.find_elements(:xpath => ".//*").size != 0
                    response_hash[$tempObjectName_Right][@aSOP_Headers[idx]]=hv.find_element(:xpath => "./img").attribute("alt") unless hv.find_elements(:xpath => ".//*").size == 0
                  end
                end
              end
  	  			end
    			end
        end
        @driver.manage.timeouts.implicit_wait = @implicitWait
  			return response_hash
  		rescue
  			puts $!
	      puts $@
      ensure
        @driver.manage.timeouts.implicit_wait = @implicitWait
  		end
  	end
  	# -----------------------------

    # -----------------------------
    # set_Profiles_StandardObjectPermissions
    # => hValues = Hash of the values to be set for the indicated Profile/Section
    # => Returns true/false
    #
    def set_Profiles_StandardObjectPermissions(hValues)
      @driver.manage.timeouts.implicit_wait = 0
      blnReturn=false
      @aSOP_Headers=[]

      get_Profiles_StandardObjectPermissions_table.each_with_index do |row, index|
        next if index < 2
        if index == 2
          row.find_elements(:xpath => "./td[2]/table/tbody/tr[2]/th").each do |header|
            @aSOP_Headers.push(header.text)
          end
        else
          # -- Left Column of Table
          row.find_elements(:xpath => "./td[1]/table/tbody/tr/td").each_with_index do |hv, idx|
            if hv.find_elements(:xpath => ".//*").size > 0
              sOrgSetting = hv.find_element(:xpath => "./input").selected? ? "Checked" : "Not Checked"
              if !(sOrgSetting == hValues[row.find_element(:xpath => "./th[1]").text][@aSOP_Headers[idx]])
                hv.find_element(:xpath => "./input").click
                sMsg=""
                a=@driver.switch_to.alert rescue "Exception happened"
                if !(a == "Exception happened")
                  sMsg= "Accepting Alert: #{a.text}"
                  a.accept
                end
                blnReturn=true
              end
            end
          end          

          # -- Right Column of Table
          if row.find_element(:xpath => "./td[2]").attribute("class") != "labelCol last empty"
            row.find_elements(:xpath => "./td[2]/table/tbody/tr/td").each_with_index do |hv, idx|
              if hv.find_elements(:xpath => ".//*").size > 0
                sOrgSetting = hv.find_element(:xpath => "./input").selected? ? "Checked" : "Not Checked"
                if !(sOrgSetting == hValues[row.find_element(:xpath => "./th[2]").text][@aSOP_Headers[idx]])
                  hv.find_element(:xpath => "./input").click
                  sMsg=""
                  a=@driver.switch_to.alert rescue "Exception happened"
                  if !(a == "Exception happened")
                    sMsg= "Accepting Alert: #{a.text}"
                    a.accept
                  end
                  blnReturn=true
                end
              end
            end
          end

        end
      end

      @driver.manage.timeouts.implicit_wait = @implicitWait
      return blnReturn
    end
    # -----------------------------

    # -----------------------------
    # get_Profiles_CustomObjectPermissions
    # => Returns an Nested Hash; {Object Name =>{Key = Header Name, Value = Checked/Unchecked}}
    #
    def get_Profiles_CustomObjectPermissions
      @driver.manage.timeouts.implicit_wait = 0
      begin
        @aCOP_Headers=[]
        response_hash = Hash.new {|h,k| h[k] = Hash.new(&h.default_proc) }
        
        if get_Profiles_CustomProfile_CheckboxValue
          get_Profiles_CustomObjectPermissions_table.each_with_index do |row, index|
            if index == 0
              row.find_elements(:xpath => "./td[2]/table/tbody/tr[2]/th").each do |header|
                @aCOP_Headers.push(header.text.strip! || header.text)
              end
            else
              # -- Left Column of Table
              $tempObjectName_Left=row.find_element(:xpath => "./th[1]").text
              row.find_elements(:xpath => "./td[1]/table/tbody/tr/td").each_with_index do |hv, idx|
                # puts "Main Table Index: #{index}; Left Column Index: #{idx}"
                print "\rMain Table Index: #{index}; Left Column Index: #{idx}"
                response_hash[$tempObjectName_Left][@aCOP_Headers[idx]]=hv.find_element(:xpath => "./img").attribute("alt") unless hv.find_elements(:xpath => ".//*").size == 0
              end
              
              # -- Right Column of Table
              if row.find_element(:xpath => "./td[2]").attribute("class") != "labelCol last empty"
                $tempObjectName_Right=row.find_element(:xpath => "./th[2]").text
                row.find_elements(:xpath => "./td[2]/table/tbody/tr/td").each_with_index do |hv, idx|
                  if hv.find_elements(:xpath => ".//*").size != 0
                    # puts "Main Table Index: #{index}; Right Column Index: #{idx}"
                    print "\rMain Table Index: #{index}; Right Column Index: #{idx}"
                    response_hash[$tempObjectName_Right][@aCOP_Headers[idx]]=hv.find_element(:xpath => "./img").attribute("alt") #unless hv.find_elements(:xpath => ".//*").size == 0
                  end
                end
              end
            end
          end
        end
        @driver.manage.timeouts.implicit_wait = @implicitWait
        return response_hash
      rescue
        puts $!
        puts $@
      ensure
        puts " "
        @driver.manage.timeouts.implicit_wait = @implicitWait
      end
    end
    # -----------------------------

    # -----------------------------
    # set_Profiles_CustomObjectPermissions
    # => hValues = Hash of the values to be set for the indicated Profile/Section
    # => Returns true/false
    #
    def set_Profiles_CustomObjectPermissions(hValues)
      @driver.manage.timeouts.implicit_wait = 0
      @aCOP_Headers=[]
      blnReturn=false

      get_Profiles_CustomObjectPermissions_table.each_with_index do |row, index|
        if index == 0
          row.find_elements(:xpath => "./td[2]/table/tbody/tr[2]/th").each do |header|
            @aCOP_Headers.push(header.text)
          end
        else
          # -- Left Column of Table
          row.find_elements(:xpath => "./td[1]/table/tbody/tr/td").each_with_index do |hv, idx|
            if hv.find_elements(:xpath => ".//*").size > 0
              sOrgSetting = hv.find_element(:xpath => "./input").selected? ? "Checked" : "Not Checked"
              print "Row/Index: #{index}; Label: #{row.find_element(:xpath => "./th[1]").text}; Hash Include True/False: #{hValues.include?(row.find_element(:xpath => "./th[1]").text)}\r"
              if hValues.include?(row.find_element(:xpath => "./th[1]").text)
                if !(sOrgSetting == hValues[row.find_element(:xpath => "./th[1]").text][@aCOP_Headers[idx]])
                  hv.find_element(:xpath => "./input").click
                  sMsg=""
                  a=@driver.switch_to.alert rescue "Exception happened"
                  if !(a == "Exception happened")
                    sMsg= "Accepting Alert: #{a.text}"
                    a.accept
                  end
                  blnReturn=true
                end
              end
            end
          end
          # -- Right Column of Table
          if row.find_element(:xpath => "./td[2]").attribute("class") != "labelCol last empty"
            row.find_elements(:xpath => "./td[2]/table/tbody/tr/td").each_with_index do |hv, idx|
              if hv.find_elements(:xpath => ".//*").size > 0
                sOrgSetting = hv.find_element(:xpath => "./input").selected? ? "Checked" : "Not Checked"
                if !(sOrgSetting == hValues[row.find_element(:xpath => "./th[2]").text][@aCOP_Headers[idx]])
                  hv.find_element(:xpath => "./input").click
                  sMsg=""
                  a=@driver.switch_to.alert rescue "Exception happened"
                  if !(a == "Exception happened")
                    sMsg= "Accepting Alert: #{a.text}"
                    a.accept
                  end
                  blnReturn=true
                end
              end
            end
          end
        end
      end
      @driver.manage.timeouts.implicit_wait = @implicitWait
      print "\n"
      return blnReturn
    end
    # -----------------------------

    # -----------------------------
    # get_Profiles_ApexClassAccess
    # => Returns an Array; [ApexClassAccess1, ApexClassAccess2]
    #
    def get_Profiles_ApexClassAccess
      @driver.manage.timeouts.implicit_wait = 0
      begin
        aResponse=[]
        if get_Profiles_CustomProfile_CheckboxValue
          puts "Apex Class Access Row Count: #{get_Profiles_ApexClassAccess_table.size}"
          get_Profiles_ApexClassAccess_table.each do |row|
            # puts "Row Class Value: #{row.attribute("class")}"
            aResponse.push(row.find_element(:xpath => "./th[1]/a").text) unless row.attribute('class')=='headerRow'
          end
        end

        @driver.manage.timeouts.implicit_wait = @implicitWait
        return aResponse
      rescue
        puts $!
        puts $@
      ensure
        @driver.manage.timeouts.implicit_wait = @implicitWait
      end
    end
    # -----------------------------

    # -----------------------------
    # set_Profiles_ApexClassAccess
    # => hValues = Hash of the values to be set for the indicated Profile/Section
    # => Returns true/false
    #
    def set_Profiles_ApexClassAccess(hValues)
      @driver.manage.timeouts.implicit_wait = 0
      blnReturn=false
      begin
        hValues.each do |value|
          options=get_Profiles_ApexClassAccess_AvailableSelect
          options.each do |option_s|
            if option_s.text == value
              option_s.click
              click_btn_Profiles_ApexClassAccess_Add
              blnReturn=true
              break
            end
          end
        end

        @driver.manage.timeouts.implicit_wait = @implicitWait
        return blnReturn
      rescue
        puts $!
        puts $@
      ensure
        @driver.manage.timeouts.implicit_wait = @implicitWait
      end
    end
    # -----------------------------

    # -----------------------------
    # get_Profiles_VisualforcePageAccess
    # => Returns an Array; [VfPageAccess1, VfPageAccess2]
    #
    def get_Profiles_VisualforcePageAccess
      @driver.manage.timeouts.implicit_wait = 0
      begin
        aResponse=[]
        puts "Visualforce Page Access Row Count: #{get_Profiles_VisualforcePageAccess_table.size}"
        get_Profiles_VisualforcePageAccess_table.each do |row|
          aResponse.push(row.find_element(:xpath => "./th[1]/a").text) unless row.attribute('class')=='headerRow'
        end
      
        @driver.manage.timeouts.implicit_wait = @implicitWait
        return aResponse
      rescue
        puts $!
        puts $@
      ensure
        @driver.manage.timeouts.implicit_wait = @implicitWait
      end
    end
    # -----------------------------

    # -----------------------------
    # set_Profiles_VisualforcePageAccess
    # => hValues = Hash of the values to be set for the indicated Profile/Section
    # => Returns true/false
    #
    def set_Profiles_VisualforcePageAccess(hValues)
      @driver.manage.timeouts.implicit_wait = 0
      blnReturn=false
      begin
        # -- Remove already 'enabled' VF Pages from hValues
        hValues.each do |value|
          options=get_Profile_VisualforcePageAccess_EnabledSelect
          options.each do |option_es|
            if option_es.text == value
              hValues=hValues - [value]
              break
            end
          end
        end
        puts "hValue Count after looking at enabled list: #{hValues.size}"

        hValues.each do |value|
          options=get_Profiles_ApexClassAccess_AvailableSelect
          options.each do |option_s|
            if option_s.text == value
              option_s.click
              click_btn_Profiles_ApexClassAccess_Add
              blnReturn=true
              break
            end
          end
        end

        @driver.manage.timeouts.implicit_wait = @implicitWait
        return blnReturn
      rescue
        puts $!
        puts $@
      ensure
        @driver.manage.timeouts.implicit_wait = @implicitWait
      end
    end
    # -----------------------------

  end
end