# ----------------------------------------------
# - Page: Rename Tabs and Labels
# ----------------------------------------------

module SfdcSe
  class Driver
  	
  	# -----------------------------
  	# get_RenameTabsLabels_Language
  	# => returns all the elements for the Translate Language dropdown
  	#
  	def get_RenameTabsLabels_Language
		return @driver.find_elements(:xpath => "//div[@class='renameTabsLanguageSelect']/select/option")
  	end
  	# -----------------------------

  	# -----------------------------
    # get_RenameTabsLabels_StandardTable
    # => returns all the elements for the Rename Tabs and Labels Standard Tabs Table
  	def get_RenameTabsLabels_StandardTable
  		# return @driver.find_elements(:xpath => "//table[@class='list'][1]/tbody/tr")
      return @driver.find_elements(:xpath => "//form[@id='thisform']/div[2]/div[1]/div/div[2]/table[@class='list']/tbody/tr")
    end
  	# -----------------------------

    # -----------------------------
    # get_RenameTabsLabels_CustomTable
    # => returns all the elements for the Rename Tabs and Labels Custom Tabs Table
    def get_RenameTabsLabels_CustomTable
      # return @driver.find_elements(:xpath => "//table[@class='list'][2]/tbody/tr")
      return @driver.find_elements(:xpath => "//form[@id='thisform']/div[3]/div[1]/div/div[2]/table[@class='list']/tbody/tr")
      # /html/body/div/div[2]/table/tbody/tr/td[2]/form/div[3]/div[1]/div/div[2]/table
    end
    # -----------------------------

  	# -----------------------------
    # get_RenameTabsLabels_StandardTable_Step1_Subtable
    # => sSubTableName
    # => returns all the elements for the Raname Tabs and Labels Standard Sub Table
  	def get_RenameTabsLabels_StandardTable_Step1_Subtable(sSubTableName)
  		return @driver.find_elements(:xpath => "//h3[contains(.,'#{sSubTableName}')]/../following-sibling::div[1]/table/tbody/tr")
  	end
  	# -----------------------------

  	# -----------------------------
    # get_RenameTabsLabels_StandardTable_Step1
    # => returns all the elements for the Rename Tabs and Labels Standard Tabs Table
  	def get_RenameTabsLabels_StandardTable_Step1
  		return @driver.find_elements(:xpath => "//table[@class='detailList']/tbody/tr")
  	end
  	# -----------------------------

  	# -----------------------------
    # get_RenameTabsLabels_StandardTable_Step2_StandardField
    # => returns all the elements for the Rename Tabs and Labels Standard Tabs Table
  	def get_RenameTabsLabels_StandardTable_Step2_StandardField
  		# return @driver.find_elements(:xpath => "//table[@class='list']/tbody/tr")
  		return @driver.find_elements(:xpath => "//div[@class='listRelatedObject setupBlock'][1]/div/div[2]/table/tbody/tr")
  		# return @driver.find_elements(:xpath => "/html/body/div/div[2]/table/tbody/tr/td[2]/form/div/div[2]/div[4]/div[2]/div/div[2]/table/tbody/tr")
  	end
  	# -----------------------------

  	# -----------------------------
    # get_RenameTabsLabels_StandardTable_Step2_OtherLabels
    # => returns all the elements for the Rename Tabs and Labels Other Labels Table
  	def get_RenameTabsLabels_StandardTable_Step2_OtherLabels
  		# return @driver.find_elements(:xpath => "//table[@class='list']/tbody/tr")
  		return @driver.find_elements(:xpath => "//div[@class='listRelatedObject setupBlock'][2]/div/div[2]/table/tbody/tr")
  												# /html/body/div/div[2]/table/tbody/tr/td[2]/form/div/div[2]/div[4]/div[4]/div/div[2]/table/tbody/tr[1]
  	end
  	# -----------------------------

  	# -----------------------------
  	# set_RenameTabsLabels_Language
  	# => sLanguage = string value of the Language option to select
    # => Return = true or false
    # =>    true  = setting of view were successful
    # =>    false = setting of view had an error
    #
  	def set_RenameTabsLabels_Language(sLanguage)
  	  	blnReturn=false

  	  	begin
  			get_RenameTabsLabels_Language.each do |option|
  				if option.text == sLanguage
  					option.click unless option.selected?
  					blnReturn=true
  					sleep(3)
  					break
  				end
  			end
  		rescue
  			puts $!
	    	puts $@
  		end
  		return blnReturn
  	end
  	# -----------------------------

  	# -----------------------------
    # click_Edit_RenameTabsLabels
    # => sTabName = string value of the Tab Name to click Edit
    # => Return = true or false
    # =>    true = value was found and 'edit' clicked
    # =>    false =value was not found or had an error
    #
    def click_Edit_RenameTabsLabels(sTabName)
      blnEdit=false
      sFoundIn='empty'
      
      r=0
      puts "Standard Rows: #{get_RenameTabsLabels_StandardTable.length}"
      while r < get_RenameTabsLabels_StandardTable.length
        $stdout.flush
        print "\r#{r} of #{get_RenameTabsLabels_StandardTable.length} - Standard:: #{get_RenameTabsLabels_StandardTable[r].find_element(:xpath => "./th[1]").text}"
      	if get_RenameTabsLabels_StandardTable[r].find_element(:xpath => "./th[1]").text == sTabName
        	get_RenameTabsLabels_StandardTable[r].find_element(:xpath => "./td[1]/a[1]").click
          sleep(5)
          sFoundIn='standard'
          blnEdit=true
          break
        end
        r+=1
      end

      r=0
      puts ""
      puts "Custom Rows: #{get_RenameTabsLabels_CustomTable.length}"
      while r < get_RenameTabsLabels_CustomTable.length
        print "\r#{r} of #{get_RenameTabsLabels_CustomTable.length} - Custom:: #{get_RenameTabsLabels_CustomTable[r].find_element(:xpath => "./th[1]").text}"
        if get_RenameTabsLabels_CustomTable[r].find_element(:xpath => "./th[1]").text == sTabName
          get_RenameTabsLabels_CustomTable[r].find_element(:xpath => "./td[1]/a[1]").click
          sleep(5)
          sFoundIn='custom'
          blnEdit=true
          break
        end
        r+=1
      end

      print "\r #{blnEdit}, #{sFoundIn}"
      return blnEdit, sFoundIn
    end
    # -----------------------------

    # -----------------------------
    # click_Btn_RenameTabslabels_Cancel
    # => Clicks the 'Cancel' button within the Rename Tabs and Labels
    def click_Btn_RenameTabslabels_Cancel
    	
      @driver.find_element(:xpath => "//div[@class='pbTopButtons']/input[@class='btnCancel']").click
    end
    # -----------------------------

    # -----------------------------
    # click_Btn_RenameTabslabels_Save
    # => Clicks the 'Save' button within the Rename Tabs and Labels
    def click_Btn_RenameTabslabels_Save
      @driver.find_element(:xpath => "//div[@class='pbTopButtons']/input[@class='btn' and @title='Save']").click
    end
    # -----------------------------

    # -----------------------------
    # click_Btn_RenameTabslabels_Next
    # => Clicks the 'Next' button within the Rename Tabs and Labels
    def click_Btn_RenameTabslabels_Next
    	@driver.find_element(:xpath => "//div[@class='pbTopButtons']/input[@class='btn' and @title='Next']").click
    end
    # -----------------------------

    # -----------------------------
  	# get_RenameTabsLabels_Standard
  	# => Return = Hash {Key= Field Name/Type, Value=Field Value}
  	#
  	def get_RenameTabsLabels_Standard
  		response=Hash.new
  		# -- Step 1 of 2
  		case get_RenameTabsLabels_StandardTable_Step1[1].find_element(:xpath => "./td[2]").text
  		when "English", "English (UK)"
  			get_RenameTabsLabels_StandardTable_Step1.each_with_index do |row, idx|
  				case idx
  				when 0,1
  					response[row.find_element(:xpath => "./td[1]").text] = row.find_element(:xpath => "./td[2]").text
  				when 2,3
  					response[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] = row.find_element(:xpath => "./td[2]/div/input").attribute("value")
  				when 4
  					response[row.find_element(:xpath => "./td[1]/label").text] = !row.find_element(:xpath => "./td[2]/input").attribute("checked").nil? 
  				end
  			end
  		when "Indonesian"
  			get_RenameTabsLabels_StandardTable_Step1.each_with_index do |row, idx|
  				case idx
  				when 0,1
  					response[row.find_element(:xpath => "./td[1]").text] = row.find_element(:xpath => "./td[2]").text
  				when 2,3
  					response[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] = row.find_element(:xpath => "./td[2]/div/input").attribute("value")
  				end
  			end
  		when "German"
  			# - Get Tab, Language, Gender
  			get_RenameTabsLabels_StandardTable_Step1.each_with_index do |row, idx|
  				case idx
  				when 0,1
  					response[row.find_element(:xpath => "./td[1]").text] = row.find_element(:xpath => "./td[2]").text
  				when 2
  					response[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] = row.find_element(:xpath => "./td[2]/div/select/option[@selected='selected']").text
  				end
  			end

  			# - Get Sub Table information
  			aSubTables=['Nominative', 'Accusative', 'Genitive', 'Dative']
  			aSubTables.each do |s|
  				subresponse=Hash.new
	  			get_RenameTabsLabels_StandardTable_Step1_Subtable(s).each do |row|
	  				subresponse[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] = row.find_element(:xpath => "./td[2]/div/input").attribute("value")
	  			end
	  			response[s]=subresponse
	  		end
	  	when "Romanian"
  			# - Get Tab, Language, Gender
  			get_RenameTabsLabels_StandardTable_Step1.each_with_index do |row, idx|
  				case idx
  				when 0,1
  					response[row.find_element(:xpath => "./td[1]").text] = row.find_element(:xpath => "./td[2]").text
  				when 2
  					response[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] = row.find_element(:xpath => "./td[2]/div/select/option[@selected='selected']").text
  				end
  			end

  			# - Get Sub Table information
  			aSubTables=['Nominative', 'Dative']
  			aSubTables.each do |s|
  				subresponse=Hash.new
	  			get_RenameTabsLabels_StandardTable_Step1_Subtable(s).each do |row|
	  				subresponse[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] = row.find_element(:xpath => "./td[2]/div/input").attribute("value")
	  			end
	  			response[s]=subresponse
	  		end
  		when "Spanish", "Portuguese (Brazilian)", "Dutch", "Spanish (Mexican)", "Bulgarian", "Portuguese (European)"
  			get_RenameTabsLabels_StandardTable_Step1.each_with_index do |row, idx|
  				case idx
  				when 0,1
  					response[row.find_element(:xpath => "./td[1]").text] = row.find_element(:xpath => "./td[2]").text
  				when 2
  					response[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")]=row.find_element(:xpath => "./td[2]/div/select/option[@selected='selected']").text
  				when 3,4
  					response[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] = row.find_element(:xpath => "./td[2]/div/input").attribute("value")
  				end
  			end
  		when "French"
  			get_RenameTabsLabels_StandardTable_Step1.each_with_index do |row, idx|
  				case idx
  				when 0,1
  					response[row.find_element(:xpath => "./td[1]").text] = row.find_element(:xpath => "./td[2]").text
  				when 2
  					response[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")]=row.find_element(:xpath => "./td[2]/div/select/option[@selected='selected']").text
  				when 3,4
  					response[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] = row.find_element(:xpath => "./td[2]/div/input").attribute("value")
  				when 5
  					response[row.find_element(:xpath => "./td[1]/label").text] = !row.find_element(:xpath => "./td[2]/input").attribute("checked").nil? 	
  				end
  			end
  		when "Italian"
  			get_RenameTabsLabels_StandardTable_Step1.each_with_index do |row, idx|
  				case idx
  				when 0,1
  					response[row.find_element(:xpath => "./td[1]").text] = row.find_element(:xpath => "./td[2]").text
  				when 2
  					response[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")]=row.find_element(:xpath => "./td[2]/div/select/option[@selected='selected']").text
  				when 3,4
  					response[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] = row.find_element(:xpath => "./td[2]/div/input").attribute("value")
  				when 5
  					response[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] = row.find_element(:xpath => "./td[2]/div/select/option[@selected='selected']").text	
  				end
  			end
  		when "Japanese", "Korean", "Chinese (Traditional)", "Chinese (Simplified)", "Thai", "Vietnamese"
  			get_RenameTabsLabels_StandardTable_Step1.each_with_index do |row, idx|
  				case idx
  				when 0,1
  					response[row.find_element(:xpath => "./td[1]").text] = row.find_element(:xpath => "./td[2]").text
  				when 2
  					response[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] = row.find_element(:xpath => "./td[2]/div/input").attribute("value")
  				end
  			end
  		when "Swedish", "Danish", "Norwegian", "Hebrew", "Arabic"
  			get_RenameTabsLabels_StandardTable_Step1.each_with_index do |row, idx|
  				case idx
  				when 0,1
  					response[row.find_element(:xpath => "./td[1]").text] = row.find_element(:xpath => "./td[2]").text
  				when 2
  					response[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] = row.find_element(:xpath => "./td[2]/div/select/option[@selected='selected']").text	
  				else
  					response[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] = row.find_element(:xpath => "./td[2]/div/input").attribute("value")
  				end
  			end
  		when "Finnish"
  			# - Get Tab, Language
  			get_RenameTabsLabels_StandardTable_Step1.each_with_index do |row, idx|
  				case idx
  				when 0,1
  					response[row.find_element(:xpath => "./td[1]").text] = row.find_element(:xpath => "./td[2]").text
  				end
  				break if idx > 1
  			end
  			
  			# - Get Sub section information
  			aSubTables=['Nominative', 'Genitive', 'Inessive', 'Elative', 'Illative', 'Adessive', 'Ablative', 'Allative', 'Essive', 'Translative', 'Partitive']
  			aSubTables.each do |s|
  				subresponse=Hash.new
	  			get_RenameTabsLabels_StandardTable_Step1_Subtable(s).each do |row|
	  				subresponse[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] = row.find_element(:xpath => "./td[2]/div/input").attribute("value")
	  			end
	  			response[s]=subresponse
	  		end
	  	when "Russian"
  			# - Get Tab, Language, Gender
  			get_RenameTabsLabels_StandardTable_Step1.each_with_index do |row, idx|
  				case idx
  				when 0,1
  					response[row.find_element(:xpath => "./td[1]").text] = row.find_element(:xpath => "./td[2]").text
  				when 2
  					response[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] = row.find_element(:xpath => "./td[2]/div/select/option[@selected='selected']").text
  				end
  			end

  			# - Get Sub section information
  			aSubTables=['Nominative', 'Accusative', 'Genitive', 'Dative', 'Instrumental', 'Prepositional']
  			aSubTables.each do |s|
  				subresponse=Hash.new
	  			get_RenameTabsLabels_StandardTable_Step1_Subtable(s).each do |row|
	  				subresponse[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] = row.find_element(:xpath => "./td[2]/div/input").attribute("value")
	  			end
	  			response[s]=subresponse
	  		end
	  	when "Hungarian"
	  		# - Get Tab, Language
  			get_RenameTabsLabels_StandardTable_Step1.each_with_index do |row, idx|
  				case idx
  				when 0,1
  					response[row.find_element(:xpath => "./td[1]").text] = row.find_element(:xpath => "./td[2]").text
  				end
  				break if idx > 1
  			end
  			
  			# - Get Sub section information
  			aSubTables=['Nominative', 'Accusative', 'Dative', 'Inessive', 'Elative', 'Illative', 'Ablative', 'Allative', 'Translative', 'Instrumental', 'Sublative', 'Superessive', 'Delative', 'Causal-Final', 'Essive-Formal', 'Terminative']
  			aSubTables.each do |s|
  				subresponse=Hash.new
	  			get_RenameTabsLabels_StandardTable_Step1_Subtable(s).each do |row|
	  				subresponse[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] = row.find_element(:xpath => "./td[2]/div/input").attribute("value")
	  			end
	  			response[s]=subresponse
	  		end

	  		# - Get final Sub section information that has checkbox in the last row
	  		subresponse=Hash.new
	  		get_RenameTabsLabels_StandardTable_Step1_Subtable('Distributive').each_with_index do |row, idx|
  				if idx < 6
  					subresponse[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] = row.find_element(:xpath => "./td[2]/div/input").attribute("value")
  				else
  					subresponse[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] = !row.find_element(:xpath => "./td[2]/input").attribute("checked").nil?
  				end
  			end
  			response['Distributive']=subresponse
  		when "Polish", "Czech", "Ukrainian", "Slovene"
  			# - Get Tab, Language, Gender
  			get_RenameTabsLabels_StandardTable_Step1.each_with_index do |row, idx|
  				case idx
  				when 0,1
  					response[row.find_element(:xpath => "./td[1]").text] = row.find_element(:xpath => "./td[2]").text
  				when 2
  					response[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] = row.find_element(:xpath => "./td[2]/div/select/option[@selected='selected']").text
  				end
  			end

  			# - Get Sub section information
  			aSubTables=['Nominative', 'Accusative', 'Genitive', 'Dative', 'Instrumental', 'Locative', 'Vocative']
  			aSubTables.each do |s|
  				subresponse=Hash.new
	  			get_RenameTabsLabels_StandardTable_Step1_Subtable(s).each do |row|
	  				subresponse[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] = row.find_element(:xpath => "./td[2]/div/input").attribute("value")
	  			end
	  			response[s]=subresponse
	  		end
	  	when "Turkish"
  			# - Get Tab, Language
  			get_RenameTabsLabels_StandardTable_Step1.each_with_index do |row, idx|
  				case idx
  				when 0,1
  					response[row.find_element(:xpath => "./td[1]").text] = row.find_element(:xpath => "./td[2]").text
  				end
  				break if idx > 1
  			end
  			
  			# - Get Sub section information
  			aSubTables=['Nominative', 'Accusative', 'Genitive', 'Dative', 'Ablative', 'Locative']
  			aSubTables.each do |s|
  				subresponse=Hash.new
	  			get_RenameTabsLabels_StandardTable_Step1_Subtable(s).each do |row|
	  				subresponse[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] = row.find_element(:xpath => "./td[2]/div/input").attribute("value")
	  			end
	  			response[s]=subresponse
	  		end
	  	when "Greek"
  			# - Get Tab, Language, Gender
  			get_RenameTabsLabels_StandardTable_Step1.each_with_index do |row, idx|
  				case idx
  				when 0,1
  					response[row.find_element(:xpath => "./td[1]").text] = row.find_element(:xpath => "./td[2]").text
  				when 2
  					response[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] = row.find_element(:xpath => "./td[2]/div/select/option[@selected='selected']").text
  				end
  			end
  			
  			# - Get Sub section information
  			aSubTables=['Nominative', 'Accusative', 'Genitive', 'Vocative']
  			aSubTables.each do |s|
  				subresponse=Hash.new
	  			get_RenameTabsLabels_StandardTable_Step1_Subtable(s).each do |row|
	  				subresponse[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] = row.find_element(:xpath => "./td[2]/div/input").attribute("value")
	  			end
	  			response[s]=subresponse
	  		end
	  	when "Slovak", "Croatian"
  			# - Get Tab, Language, Gender
  			get_RenameTabsLabels_StandardTable_Step1.each_with_index do |row, idx|
  				case idx
  				when 0,1
  					response[row.find_element(:xpath => "./td[1]").text] = row.find_element(:xpath => "./td[2]").text
  				when 2
  					response[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] = row.find_element(:xpath => "./td[2]/div/select/option[@selected='selected']").text
  				end
  			end
  			
  			# - Get Sub section information
  			aSubTables=['Nominative', 'Accusative', 'Genitive', 'Dative', 'Instrumental', 'Locative']
  			aSubTables.each do |s|
  				subresponse=Hash.new
	  			get_RenameTabsLabels_StandardTable_Step1_Subtable(s).each do |row|
	  				subresponse[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] = row.find_element(:xpath => "./td[2]/div/input").attribute("value")
	  			end
	  			response[s]=subresponse
	  		end
  		end

  		# -- Click Next to get to Step 2
  		click_Btn_RenameTabslabels_Next

  		# -- Step 2 of 2
  		# --- Standard Field Labels Table
  		# puts "Step2: Standard Field Labels: #{get_RenameTabsLabels_StandardTable_Step2_StandardField.length}"
  		@driver.manage.timeouts.implicit_wait = 0
  		aStep2Headers=[]
  		iStep2HeaderCount=0
  		iTableCount=1
  		hStep2RowResponse=Hash.new
  		srowFieldLabel=''

  		while iTableCount < 3
  			if iTableCount == 1 
  				aTable=get_RenameTabsLabels_StandardTable_Step2_StandardField
  			else
  				aTable=get_RenameTabsLabels_StandardTable_Step2_OtherLabels
  			end

  			# puts "iTableCount: #{iTableCount}; Table Count: #{aTable.size}"
	  		aTable.each_with_index do |row, idx|
	  			hStep2SubRowResp=Hash.new

	  			# puts "Row: #{idx}"
	  			
	  			if idx == 0
	  				iStep2HeaderCount = row.find_elements(:xpath => "./th").length
	  				row.find_elements(:xpath => "./th").each do |subrow|
	  					aStep2Headers.push(subrow.text)
	  				end
	  			else
	  				case iStep2HeaderCount
	  				when 2
	  					# - Find countries that have only two Step 2 Header Columns
	  					srowFieldLabel=row.find_element(:xpath => "./th").text
	  					hStep2SubRowResp[aStep2Headers[1]]=row.find_element(:xpath => "./td[1]/input").attribute("value") unless row.find_elements(:xpath => "./td[1]//*").size == 0
	  				when 3
	  					# - Find countries that have only three Step 2 Header Columns
	  					srowFieldLabel=row.find_element(:xpath => "./th").text
	  					hStep2SubRowResp[aStep2Headers[1]]=row.find_element(:xpath => "./td[1]/input").attribute("value") unless row.find_elements(:xpath => "./td[1]//*").size == 0
	  					hStep2SubRowResp[aStep2Headers[2]]=row.find_element(:xpath => "./td[2]/input").attribute("value") unless row.find_elements(:xpath => "./td[2]//*").size == 0
	  				when 4
	  					# - Find countries that have only four Step 2 Header Columns
	  					srowFieldLabel=row.find_element(:xpath => "./th").text
	  					hStep2SubRowResp[aStep2Headers[1]]=row.find_element(:xpath => "./td[1]/input").attribute("value") unless row.find_elements(:xpath => "./td[1]//*").size == 0
	  					hStep2SubRowResp[aStep2Headers[2]]=row.find_element(:xpath => "./td[2]/input").attribute("value") unless row.find_elements(:xpath => "./td[2]//*").size == 0
	  					if row.find_element(:xpath => "./td[3]").attribute("class") == " dataCell  booleanColumn"
	  						# - get checkbox value
	  						hStep2SubRowResp[aStep2Headers[3]] = !row.find_element(:xpath => "./td[3]/input").attribute("checked").nil? 
	  					else
	  						# - Get gender value
	  						hStep2SubRowResp[aStep2Headers[3]] = row.find_element(:xpath => "./td[3]/select/option[@selected='selected']").text unless row.find_elements(:xpath => "./td[3]//*").size == 0
	  					end
	  				when 5
	  					# - Find countries that have only five Step 2 Header Columns
	  					srowFieldLabel=row.find_element(:xpath => "./th").text
	  					hStep2SubRowResp[aStep2Headers[1]]=row.find_element(:xpath => "./td[1]/input").attribute("value") unless row.find_elements(:xpath => "./td[1]//*").size == 0
	  					hStep2SubRowResp[aStep2Headers[2]]=row.find_element(:xpath => "./td[2]/input").attribute("value") unless row.find_elements(:xpath => "./td[2]//*").size == 0
	  					hStep2SubRowResp[aStep2Headers[3]]=row.find_element(:xpath => "./td[3]/select/option[@selected='selected']").text unless row.find_elements(:xpath => "./td[3]//*").size == 0
	  					if row.find_element(:xpath => "./td[4]").attribute("class") == " dataCell  booleanColumn"
	  						# - get checkbox value
	  						hStep2SubRowResp[aStep2Headers[4]] = !row.find_element(:xpath => "./td[4]/input").attribute("checked").nil? 
	  					else
	  						# - Get gender value
	  						hStep2SubRowResp[aStep2Headers[4]] = row.find_element(:xpath => "./td[4]/select/option[@selected='selected']").text unless row.find_elements(:xpath => "./td[4]//*").size == 0
	  					end
	  				end

	  				hStep2RowResponse[srowFieldLabel]=hStep2SubRowResp
	  			end
	  		end

	  		if iTableCount == 1
	  			response['Standard Field Labels'] = hStep2RowResponse
	  		else
	  			response['Other Labels'] = hStep2RowResponse
	  		end

	  		iTableCount +=1
	  	end

  		# -- Step 2 Other Labels
  		# puts "Step2: Other Labels Row Count: #{get_RenameTabsLabels_StandardTable_Step2_OtherLabels.size}"

  		@driver.manage.timeouts.implicit_wait = @implicitWait
  		

  		return response
  	end
  	# -----------------------------

    # -----------------------------
    # set_RenameTabsLabels_Standard
    # => Return = Hash {Key= Field Name/Type, Value=Field Value}
    #
    def set_RenameTabsLabels_Standard(hValueSet)
      blnReturn=false
      
      # -- Step 1 of 2
      case get_RenameTabsLabels_StandardTable_Step1[1].find_element(:xpath => "./td[2]").text
      when "English", "English (UK)"
        get_RenameTabsLabels_StandardTable_Step1.each_with_index do |row, idx|
          case idx
          when 0,1
            # response[row.find_element(:xpath => "./td[1]").text] = row.find_element(:xpath => "./td[2]").text
          when 2,3
            if !(row.find_element(:xpath => "./td[2]/div/input").attribute("value") == hValueSet[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")])
              row.find_element(:xpath => "./td[2]/div/input").clear()
              row.find_element(:xpath => "./td[2]/div/input").send_keys(hValueSet[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")])
              blnReturn=true
            end             

            # puts "Value for #{row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")}: #{hValueSet[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")]}"
            # response[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] = row.find_element(:xpath => "./td[2]/div/input").attribute("value")
          when 4
            if !((!row.find_element(:xpath => "./td[2]/input").attribute("checked").nil?).to_s == hValueSet[row.find_element(:xpath => "./td[1]/label").text].to_s)
              row.find_element(:xpath => "./td[2]/input").click
              blnReturn=true
            end

            # response[row.find_element(:xpath => "./td[1]/label").text] = !row.find_element(:xpath => "./td[2]/input").attribute("checked").nil? 
          end
        end
      when "Indonesian"
        get_RenameTabsLabels_StandardTable_Step1.each_with_index do |row, idx|
          case idx
          when 0,1
            # response[row.find_element(:xpath => "./td[1]").text] = row.find_element(:xpath => "./td[2]").text
          when 2,3
            if !(row.find_element(:xpath => "./td[2]/div/input").attribute("value") == hValueSet[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")])
              row.find_element(:xpath => "./td[2]/div/input").clear()
              row.find_element(:xpath => "./td[2]/div/input").send_keys(hValueSet[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")])
              blnReturn=true
            end

            # response[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] = row.find_element(:xpath => "./td[2]/div/input").attribute("value")
          end
        end
      when "German"
        # - Get Tab, Language, Gender
        get_RenameTabsLabels_StandardTable_Step1.each_with_index do |row, idx|
          case idx
          when 0,1
            # response[row.find_element(:xpath => "./td[1]").text] = row.find_element(:xpath => "./td[2]").text
          when 2
            if !(row.find_element(:xpath => "./td[2]/div/select/option[@selected='selected']").text == hValueSet[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")])
              row.find_elements(:xpath => "./td[2]/div/select/option").each do |option|
                if option.text == hValueSet[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")]
                  option.click
                  blnReturn=true
                  sleep(3)
                  break
                end
              end
            end

            # response[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] = row.find_element(:xpath => "./td[2]/div/select/option[@selected='selected']").text
          end
        end

        # - Get Sub Table information
        aSubTables=['Nominative', 'Accusative', 'Genitive', 'Dative']
        aSubTables.each do |s|
          get_RenameTabsLabels_StandardTable_Step1_Subtable(s).each do |row|
            if !(row.find_element(:xpath => "./td[2]/div/input").attribute("value") == hValueSet[s][row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")])
              row.find_element(:xpath => "./td[2]/div/input").clear()
              row.find_element(:xpath => "./td[2]/div/input").send_keys(hValueSet[s][row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")])
              blnReturn=true
            end

            # subresponse[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] = row.find_element(:xpath => "./td[2]/div/input").attribute("value")
          end
        end
      when "Romanian"
        # - Get Tab, Language, Gender
        get_RenameTabsLabels_StandardTable_Step1.each_with_index do |row, idx|
          case idx
          when 0,1
            # response[row.find_element(:xpath => "./td[1]").text] = row.find_element(:xpath => "./td[2]").text
          when 2
            if !(row.find_element(:xpath => "./td[2]/div/select/option[@selected='selected']").text == hValueSet[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")])
              row.find_elements(:xpath => "./td[2]/div/select/option").each do |option|
                if option.text == hValueSet[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")]
                  option.click
                  blnReturn=true
                  sleep(3)
                  break
                end
              end
            end

            # response[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] = row.find_element(:xpath => "./td[2]/div/select/option[@selected='selected']").text
          end
        end

        # - Get Sub Table information
        aSubTables=['Nominative', 'Dative']
        aSubTables.each do |s|
          get_RenameTabsLabels_StandardTable_Step1_Subtable(s).each do |row|
            if !(row.find_element(:xpath => "./td[2]/div/input").attribute("value") == hValueSet[s][row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")])
              row.find_element(:xpath => "./td[2]/div/input").clear()
              row.find_element(:xpath => "./td[2]/div/input").send_keys(hValueSet[s][row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")])
              blnReturn=true
            end

            # subresponse[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] = row.find_element(:xpath => "./td[2]/div/input").attribute("value")
          end
        end
      when "Spanish", "Portuguese (Brazilian)", "Dutch", "Spanish (Mexican)", "Bulgarian", "Portuguese (European)"
        get_RenameTabsLabels_StandardTable_Step1.each_with_index do |row, idx|
          case idx
          when 0,1
            # response[row.find_element(:xpath => "./td[1]").text] = row.find_element(:xpath => "./td[2]").text
          when 2
            if !(row.find_element(:xpath => "./td[2]/div/select/option[@selected='selected']").text == hValueSet[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")])
              row.find_elements(:xpath => "./td[2]/div/select/option").eah do |option|
                if option.text == hValueSet[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")]
                  option.click
                  blnReturn=true
                  break
                end
              end
            end

            # response[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")]=row.find_element(:xpath => "./td[2]/div/select/option[@selected='selected']").text
          when 3,4
            if !(row.find_element(:xpath => "./td[2]/div/input").attribute("value") == hValueSet[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")])
              row.find_element(:xpath => "./td[2]/div/input").clear()
              row.find_element(:xpath => "./td[2]/div/input").send_keys(hValueSet[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")])
              blnReturn=true
            end

            # response[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] = row.find_element(:xpath => "./td[2]/div/input").attribute("value")
          end
        end
      when "French"
        get_RenameTabsLabels_StandardTable_Step1.each_with_index do |row, idx|
          case idx
          when 0,1
            # response[row.find_element(:xpath => "./td[1]").text] = row.find_element(:xpath => "./td[2]").text
          when 2
            if !(row.find_element(:xpath => "./td[2]/div/select/option[@selected='selected']").text == hValueSet[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")])
              row.find_elements(:xpath => "./td[2]/div/select/option").each do |option|
                if option.text == hValueSet[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")]
                  option.click
                  blnReturn=true
                  break
                end
              end
            end

            # response[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")]=row.find_element(:xpath => "./td[2]/div/select/option[@selected='selected']").text
          when 3,4
            if !(row.find_element(:xpath => "./td[2]/div/input").attribute("value") == hValueSet[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")])
              row.find_element(:xpath => "./td[2]/div/input").clear
              row.find_element(:xpath => "./td[2]/div/input").send_keys(hValueSet[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")])
              blnReturn=true
            end

            # response[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] = row.find_element(:xpath => "./td[2]/div/input").attribute("value")
          when 5
            if !((!row.find_element(:xpath => "./td[2]/input").attribute("checked").nil?).to_s == hValueSet[row.find_element(:xpath => "./td[1]/label").text].to_s)
              row.find_element(:xpath => "./td[2]/input").click
              blnReturn=true
            end

            # response[row.find_element(:xpath => "./td[1]/label").text] = !row.find_element(:xpath => "./td[2]/input").attribute("checked").nil?   
          end
        end
      when "Italian"
        get_RenameTabsLabels_StandardTable_Step1.each_with_index do |row, idx|
          case idx
          when 0,1
            # response[row.find_element(:xpath => "./td[1]").text] = row.find_element(:xpath => "./td[2]").text
          when 2
            if !(row.find_element(:xpath => "./td[2]/div/select/option[@selected='selected']").text == hValueSet[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")])
              row.find_elements(:xpath => "./td[2]/div/select/option]").each do |option|
                if option.text == hValueSet[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")]
                  option.click
                  blnReturn=true
                  break
                end
              end
            end

            # response[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")]=row.find_element(:xpath => "./td[2]/div/select/option[@selected='selected']").text
          when 3,4
            if !(row.find_element(:xpath => "./td[2]/div/input").attribute("value") == hValueSet[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")])
              row.find_element(:xpath => "./td[2]/div/input").clear()
              row.find_element(:xpath => "./td[2]/div/input").send_keys(hValueSet[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")])
              blnReturn=true
            end

            # response[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] = row.find_element(:xpath => "./td[2]/div/input").attribute("value")
          when 5
            if !(row.find_element(:xpath => "./td[2]/div/select/option[@selected='selected']").text == hValueSet[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")])
              row.find_elements(:xpath => "./td[2]/div/select/option").each do |option|
                if option.text == hValueSet[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")]
                  option.click
                  blnReturn=true
                  break
                end
              end
            end

            # response[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] = row.find_element(:xpath => "./td[2]/div/select/option[@selected='selected']").text 
          end
        end
      when "Japanese", "Korean", "Chinese (Traditional)", "Chinese (Simplified)", "Thai", "Vietnamese"
        get_RenameTabsLabels_StandardTable_Step1.each_with_index do |row, idx|
          case idx
          when 0,1
            # response[row.find_element(:xpath => "./td[1]").text] = row.find_element(:xpath => "./td[2]").text
          when 2
            if !(row.find_element(:xpath => "./td[2]/div/input").attribute("value") == hValueSet[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")])
              row.find_element(:xpath => "./td[2]/div/input").clear()
              row.find_element(:xpath => "./td[2]/div/input").send_keys(hValueSet[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")])
              blnReturn=true
            end

            # response[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] = row.find_element(:xpath => "./td[2]/div/input").attribute("value")
          end
        end
      when "Swedish", "Danish", "Norwegian", "Hebrew", "Arabic"
        get_RenameTabsLabels_StandardTable_Step1.each_with_index do |row, idx|
          case idx
          when 0,1
            # response[row.find_element(:xpath => "./td[1]").text] = row.find_element(:xpath => "./td[2]").text
          when 2
            if !(row.find_element(:xpath => "./td[2]/div/select/option[@selected='selected']").text == hValueSet[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")])
              row.find_elements(:xpath => "./td[2]/div/select/option").each do |option|
                if option.text == hValueSet[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")]
                  option.click
                  blnReturn=true
                  break
                end
              end
            end

            # response[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] = row.find_element(:xpath => "./td[2]/div/select/option[@selected='selected']").text 
          else
            if !(row.find_element(:xpath => "./td[2]/div/input").attribute("value") == hValueSet[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")])
              row.find_element(:xpath => "./td[2]/div/input").clear()
              row.find_element(:xpath => "./td[2]/div/input").send_keys(hValueSet[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")])
              blnReturn=true
            end

            # response[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] = row.find_element(:xpath => "./td[2]/div/input").attribute("value")
          end
        end
      when "Finnish"
        # - Get Tab, Language
        # get_RenameTabsLabels_StandardTable_Step1.each_with_index do |row, idx|
        #   case idx
        #   when 0,1
        #     response[row.find_element(:xpath => "./td[1]").text] = row.find_element(:xpath => "./td[2]").text
        #   end
        #   break if idx > 1
        # end
        
        # - Get Sub section information
        aSubTables=['Nominative', 'Genitive', 'Inessive', 'Elative', 'Illative', 'Adessive', 'Ablative', 'Allative', 'Essive', 'Translative', 'Partitive']
        aSubTables.each do |s|
          get_RenameTabsLabels_StandardTable_Step1_Subtable(s).each do |row|
            if !(row.find_element(:xpath => "./td[2]/div/input").attribute("value") == hValueSet[s][row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")]) 
              row.find_element(:xpath => "./td[2]/div/input").clear()
              row.find_element(:xpath => "./td[2]/div/input").send_keys(hValueSet[s][row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")])
              blnReturn=true
            end

            # subresponse[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] = row.find_element(:xpath => "./td[2]/div/input").attribute("value")
          end
        end
      when "Russian"
        # - Get Tab, Language, Gender
        get_RenameTabsLabels_StandardTable_Step1.each_with_index do |row, idx|
          case idx
          when 0,1
            # response[row.find_element(:xpath => "./td[1]").text] = row.find_element(:xpath => "./td[2]").text
          when 2
            if !(row.find_element(:xpath => "./td[2]/div/select/option[@selected='selected']").text == hValueSet[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")])
              row.find_elements(:xpath => "./td[2]/div/select/option").each do |option|
                if option.text == hValueSet[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")]
                  option.click
                  blnReturn=true
                  break
                end
              end
            end

            # response[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] = row.find_element(:xpath => "./td[2]/div/select/option[@selected='selected']").text
          end
        end

        # - Get Sub section information
        aSubTables=['Nominative', 'Accusative', 'Genitive', 'Dative', 'Instrumental', 'Prepositional']
        aSubTables.each do |s|
          get_RenameTabsLabels_StandardTable_Step1_Subtable(s).each do |row|
            if !(row.find_element(:xpath => "./td[2]/div/input").attribute("value") == hValueSet[s][row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")])
              row.find_element(:xpath => "./td[2]/div/input").clear()
              row.find_element(:xpath => "./td[2]/div/input").send_keys(hValueSet[s][row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")])
              blnReturn=true
            end

            # subresponse[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] = row.find_element(:xpath => "./td[2]/div/input").attribute("value")
          end
        end
      when "Hungarian"
        # - Get Tab, Language
        # get_RenameTabsLabels_StandardTable_Step1.each_with_index do |row, idx|
        #   case idx
        #   when 0,1
        #     response[row.find_element(:xpath => "./td[1]").text] = row.find_element(:xpath => "./td[2]").text
        #   end
        #   break if idx > 1
        # end
        
        # - Get Sub section information
        aSubTables=['Nominative', 'Accusative', 'Dative', 'Inessive', 'Elative', 'Illative', 'Ablative', 'Allative', 'Translative', 'Instrumental', 'Sublative', 'Superessive', 'Delative', 'Causal-Final', 'Essive-Formal', 'Terminative']
        aSubTables.each do |s|
          get_RenameTabsLabels_StandardTable_Step1_Subtable(s).each do |row|
            if !(row.find_element(:xpath => "./td[2]/div/input").attribute("value") == hValueSet[s][row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")])
              row.find_element(:xpath => "./td[2]/div/input").clear()
              row.find_element(:xpath => "./td[2]/div/input").send_keys(hValueSet[s][row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")])
              blnReturn=true
            end

            # subresponse[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] = row.find_element(:xpath => "./td[2]/div/input").attribute("value")
          end
        end

        # - Get final Sub section information that has checkbox in the last row
        get_RenameTabsLabels_StandardTable_Step1_Subtable('Distributive').each_with_index do |row, idx|
          if idx < 6
            if !(row.find_element(:xpath => "./td[2]/div/input").attribute("value") == hValueSet['Distributive'][row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")])
              row.find_element(:xpath => "./td[2]/div/input").clear()
              row.find_element(:xpath => "./td[2]/div/input").send_keys(hValueSet['Distributive'][row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")])
              blnReturn=true
            end

            # subresponse[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] = row.find_element(:xpath => "./td[2]/div/input").attribute("value")
          else
            if !((!row.find_element(:xpath => "./td[2]/input").attribute("checked").nil?).to_s == hValueSet['Distributive'][row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")].to_s)
              row.find_element(:xpath => "./td[2]/input").click
              blnReturn=true
            end

            # subresponse[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] = !row.find_element(:xpath => "./td[2]/input").attribute("checked").nil?
          end
        end
      when "Polish", "Czech", "Ukrainian", "Slovene"
        # - Get Tab, Language, Gender
        get_RenameTabsLabels_StandardTable_Step1.each_with_index do |row, idx|
          case idx
          when 0,1
            # response[row.find_element(:xpath => "./td[1]").text] = row.find_element(:xpath => "./td[2]").text
          when 2
            if !(row.find_element(:xpath => "./td[2]/div/select/option[@selected='selected']").text == hValueSet[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")])
              row.find_elements(:xpath => "./td[2]/div/select/option").each do |option|
                if option.text == hValueSet[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")]
                  option.click
                  blnReturn=true
                  break
                end
              end
            end

            # response[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] = row.find_element(:xpath => "./td[2]/div/select/option[@selected='selected']").text
          end
        end

        # - Get Sub section information
        aSubTables=['Nominative', 'Accusative', 'Genitive', 'Dative', 'Instrumental', 'Locative', 'Vocative']
        aSubTables.each do |s|
          get_RenameTabsLabels_StandardTable_Step1_Subtable(s).each do |row|
            if !(row.find_element(:xpath => "./td[2]/div/input").attribute("value") == hValueSet[s][row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")])
              row.find_element(:xpath => "./td[2]/div/input").clear()
              row.find_element(:xpath => "./td[2]/div/input").send_keys(hValueSet[s][row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")])
              blnReturn=true
            end

            # subresponse[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] = row.find_element(:xpath => "./td[2]/div/input").attribute("value")
          end
        end
      when "Turkish"
        # - Get Tab, Language
        # get_RenameTabsLabels_StandardTable_Step1.each_with_index do |row, idx|
        #   case idx
        #   when 0,1
        #     response[row.find_element(:xpath => "./td[1]").text] = row.find_element(:xpath => "./td[2]").text
        #   end
        #   break if idx > 1
        # end
        
        # - Get Sub section information
        aSubTables=['Nominative', 'Accusative', 'Genitive', 'Dative', 'Ablative', 'Locative']
        aSubTables.each do |s|
          get_RenameTabsLabels_StandardTable_Step1_Subtable(s).each do |row|
            if !(row.find_element(:xpath => "./td[2]/div/input").attribute("value") == hValueSet[s][row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")])
              row.find_element(:xpath => "./td[2]/div/input").clear()
              row.find_element(:xpath => "./td[2]/div/input").send_keys(hValueSet[s][row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")])
              blnReturn=true
            end

            # subresponse[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] = row.find_element(:xpath => "./td[2]/div/input").attribute("value")
          end
        end
      when "Greek"
        # - Get Tab, Language, Gender
        get_RenameTabsLabels_StandardTable_Step1.each_with_index do |row, idx|
          case idx
          when 0,1
            # response[row.find_element(:xpath => "./td[1]").text] = row.find_element(:xpath => "./td[2]").text
          when 2
            if !(row.find_element(:xpath => "./td[2]/div/select/option[@selected='selected']").text == hValueSet[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")])
              row.find_elements(:xpath => "./td[2]/div/select/option").each do |option|
                if option.text == hValueSet[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")]
                  option.click
                  blnReturn=true
                  break
                end
              end
            end

            # response[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] = row.find_element(:xpath => "./td[2]/div/select/option[@selected='selected']").text
          end
        end
        
        # - Get Sub section information
        aSubTables=['Nominative', 'Accusative', 'Genitive', 'Vocative']
        aSubTables.each do |s|
          get_RenameTabsLabels_StandardTable_Step1_Subtable(s).each do |row|
            if !(row.find_element(:xpath => "./td[2]/div/input").attribute("value") == hValueSet[s][row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")])
              row.find_element(:xpath => "./td[2]/div/input").clear()
              row.find_element(:xpath => "./td[2]/div/input").send_keys(hValueSet[s][row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")])
              blnReturn=true
            end

            # subresponse[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] = row.find_element(:xpath => "./td[2]/div/input").attribute("value")
          end
        end
      when "Slovak", "Croatian"
        # - Get Tab, Language, Gender
        get_RenameTabsLabels_StandardTable_Step1.each_with_index do |row, idx|
          case idx
          when 0,1
            # response[row.find_element(:xpath => "./td[1]").text] = row.find_element(:xpath => "./td[2]").text
          when 2
            if !(row.find_element(:xpath => "./td[2]/div/select/option[@selected='selected']").text == hValueSet[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")])
              row.find_elements(:xpath => "./td[2]/div/select/option").each do |option|
                if option.text == hValueSet[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")]
                  option.click
                  blnReturn=true
                  break
                end
              end
            end

            # response[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] = row.find_element(:xpath => "./td[2]/div/select/option[@selected='selected']").text
          end
        end
        
        # - Get Sub section information
        aSubTables=['Nominative', 'Accusative', 'Genitive', 'Dative', 'Instrumental', 'Locative']
        aSubTables.each do |s|
          get_RenameTabsLabels_StandardTable_Step1_Subtable(s).each do |row|
            if !(row.find_element(:xpath => "./td[2]/div/input").attribute("value") == hValueSet[s][row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")])
              row.find_element(:xpath => "./td[2]/div/input").clear()
              row.find_element(:xpath => "./td[2]/div/input").send_keys(hValueSet[s][row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")])
              blnReturn=true
            end

            # subresponse[row.find_element(:xpath => "./td[1]/label").text.gsub("*\n", "")] = row.find_element(:xpath => "./td[2]/div/input").attribute("value")
          end
        end
      end

      # -- Click Next to get to Step 2
      click_Btn_RenameTabslabels_Next

      # -- Step 2 of 2
      # --- Standard Field Labels Table
      @driver.manage.timeouts.implicit_wait = 0
      aStep2Headers=[]
      iStep2HeaderCount=0
      iTableCount=1
      srowFieldLabel=''
      sTableType=''

      while iTableCount < 3
        if iTableCount == 1 
          aTable=get_RenameTabsLabels_StandardTable_Step2_StandardField
          sTableType='Standard Field Labels'
        else
          aTable=get_RenameTabsLabels_StandardTable_Step2_OtherLabels
          sTableType='Other Labels'
        end

        aTable.each_with_index do |row, idx|
          if idx == 0
            iStep2HeaderCount = row.find_elements(:xpath => "./th").length
            row.find_elements(:xpath => "./th").each do |subrow|
              aStep2Headers.push(subrow.text)
            end
          else
            case iStep2HeaderCount
            when 2
              # - Find countries that have only two Step 2 Header Columns
              if row.find_elements(:xpath => "./td[1]//*").size > 0
                if !(row.find_element(:xpath => "./td[1]/input").attribute("value") == hValueSet[sTableType][row.find_element(:xpath => "./th").text][aStep2Headers[1]])
                  row.find_element(:xpath => "./td[1]/input").clear()
                  row.find_element(:xpath => "./td[1]/input").send_keys(hValueSet[sTableType][row.find_element(:xpath => "./th").text][aStep2Headers[1]])
                  blnReturn=true
                end
              end

              # srowFieldLabel=row.find_element(:xpath => "./th").text
              # hStep2SubRowResp[aStep2Headers[1]]=row.find_element(:xpath => "./td[1]/input").attribute("value") unless row.find_elements(:xpath => "./td[1]//*").size == 0
            when 3
              # - Find countries that have only three Step 3 Header Columns
              if row.find_elements(:xpath => "./td[1]//*").size > 0
                if !(row.find_element(:xpath => "./td[1]/input").attribute("value") == hValueSet[sTableType][row.find_element(:xpath => "./th").text][aStep2Headers[1]])
                  row.find_element(:xpath => "./td[1]/input").clear()
                  row.find_element(:xpath => "./td[1]/input").send_keys(hValueSet[sTableType][row.find_element(:xpath => "./th").text][aStep2Headers[1]])
                  blnReturn=true
                end
              end

              if row.find_elements(:xpath => "./td[2]//*").size > 0
                if !(row.find_element(:xpath => "./td[2]/input").attribute("value") == hValueSet[sTableType][row.find_element(:xpath => "./th").text][aStep2Headers[2]])
                  row.find_element(:xpath => "./td[2]/input").clear()
                  row.find_element(:xpath => "./td[2]/input").send_keys(hValueSet[sTableType][row.find_element(:xpath => "./th").text][aStep2Headers[2]])
                end
              end

              # srowFieldLabel=row.find_element(:xpath => "./th").text
              # hStep2SubRowResp[aStep2Headers[1]]=row.find_element(:xpath => "./td[1]/input").attribute("value") unless row.find_elements(:xpath => "./td[1]//*").size == 0
              # hStep2SubRowResp[aStep2Headers[2]]=row.find_element(:xpath => "./td[2]/input").attribute("value") unless row.find_elements(:xpath => "./td[2]//*").size == 0
            when 4
              # - Find countries that have only four Step 4 Header Columns
              if row.find_elements(:xpath => "./td[1]//*").size > 0
                if !(row.find_element(:xpath => "./td[1]/input").attribute("value") == hValueSet[sTableType][row.find_element(:xpath => "./th").text][aStep2Headers[1]])
                  row.find_element(:xpath => "./td[1]/input").clear()
                  row.find_element(:xpath => "./td[1]/input").send_keys(hValueSet[sTableType][row.find_element(:xpath => "./th").text][aStep2Headers[1]])
                  blnReturn=true
                end
              end

              if row.find_elements(:xpath => "./td[2]//*").size > 0
                if !(row.find_element(:xpath => "./td[2]/input").attribute("value") == hValueSet[sTableType][row.find_element(:xpath => "./th").text][aStep2Headers[2]])
                  row.find_element(:xpath => "./td[2]/input").clear()
                  row.find_element(:xpath => "./td[2]/input").send_keys(hValueSet[sTableType][row.find_element(:xpath => "./th").text][aStep2Headers[2]])
                  blnReturn=true
                end
              end

              if row.find_element(:xpath => "./td[3]").attribute("class") == " dataCell  booleanColumn"
                # - get checkbox value
                if !((!row.find_element(:xpath => "./td[3]/input").attribute("checked").nil?).to_s == hValueSet[sTableType][row.find_element(:xpath => "./th").text][aStep2Headers[3]].to_s)
                  row.find_element(:xpath => "./td[3]/input").click
                  blnReturn=true
                end
                # hStep2SubRowResp[aStep2Headers[3]] = !row.find_element(:xpath => "./td[3]/input").attribute("checked").nil? 
              else
                # - Get gender value
                if row.find_elements(:xpath => "./td[3]//*").size > 0
                  if !(row.find_element(:xpath => "./td[3]/select/option[@selected='selected']").text == hValueSet[sTableType][row.find_element(:xpath => "./th").text][aStep2Headers[3]])
                    row.find_elements(:xpath => "./td[3]/select/option").each do |option|
                      if option.text == hValueSet[sTableType][row.find_element(:xpath => "./th").text][aStep2Headers[3]]
                        option.click
                        blnReturn=true
                        break
                      end
                    end
                  end
                end
                # hStep2SubRowResp[aStep2Headers[3]] = row.find_element(:xpath => "./td[3]/select/option[@selected='selected']").text unless row.find_elements(:xpath => "./td[3]//*").size == 0
              end

              # srowFieldLabel=row.find_element(:xpath => "./th").text
              # hStep2SubRowResp[aStep2Headers[1]]=row.find_element(:xpath => "./td[1]/input").attribute("value") unless row.find_elements(:xpath => "./td[1]//*").size == 0
              # hStep2SubRowResp[aStep2Headers[2]]=row.find_element(:xpath => "./td[2]/input").attribute("value") unless row.find_elements(:xpath => "./td[2]//*").size == 0
              # if row.find_element(:xpath => "./td[3]").attribute("class") == " dataCell  booleanColumn"
              #   # - get checkbox value
              #   hStep2SubRowResp[aStep2Headers[3]] = !row.find_element(:xpath => "./td[3]/input").attribute("checked").nil? 
              # else
              #   # - Get gender value
              #   hStep2SubRowResp[aStep2Headers[3]] = row.find_element(:xpath => "./td[3]/select/option[@selected='selected']").text unless row.find_elements(:xpath => "./td[3]//*").size == 0
              # end
            when 5
              # - Find countries that have only five Step 5 Header Columns
              # - ############################## HERE ##############################
              if row.find_elements(:xpath => "./td[1]//*").size > 0
                if !(row.find_element(:xpath => "./td[1]/input").attribute("value") == hValueSet[sTableType][row.find_element(:xpath => "./th").text][aStep2Headers[1]])
                  row.find_element(:xpath => "./td[1]/input").clear()
                  row.find_element(:xpath => "./td[1]/input").send_keys(hValueSet[sTableType][row.find_element(:xpath => "./th").text][aStep2Headers[1]])
                  blnReturn=true
                end
              end

              if row.find_elements(:xpath => "./td[2]//*").size > 0
                if !(row.find_element(:xpath => "./td[2]/input").attribute("value") == hValueSet[sTableType][row.find_element(:xpath => "./th").text][aStep2Headers[2]])
                  row.find_element(:xpath => "./td[2]/input").clear()
                  row.find_element(:xpath => "./td[2]/input").send_keys(hValueSet[sTableType][row.find_element(:xpath => "./th").text][aStep2Headers[2]])
                  blnReturn=true
                end
              end

              if row.find_elements(:xpath => "./td[3]//*").size > 0 
                if !(row.find_element(:xpath => "./td[3]/select/option[@selected='selected']").text == hValueSet[sTableType][row.find_element(:xpath => "./th").text][aStep2Headers[3]])
                  row.find_elements(:xpath => "./td[3]/select/option").each do |option|
                    if option.text == hValueSet[sTableType][row.find_element(:xpath => "./th").text][aStep2Headers[3]]
                      option.click
                      blnReturn=true
                      break
                    end
                  end
                end
              end

              if row.find_element(:xpath => "./td[4]").attribute("class") == " dataCell  booleanColumn"
                # - get checkbox value
                if !((!row.find_element(:xpath => "./td[4]/input").attribute("checked").nil? ).to_s == hValueSet[sTableType][row.find_element(:xpath => "./th").text][aStep2Headers[4]].to_s)
                  row.find_element(:xpath => "./td[4]/input").click
                  blnReturn=true
                end
                # hStep2SubRowResp[aStep2Headers[4]] = !row.find_element(:xpath => "./td[4]/input").attribute("checked").nil? 
              else
                # - Get gender value
                if row.find_elements(:xpath => "./td[4]//*").size > 0
                  if !(row.find_element(:xpath => "./td[4]/select/option[@selected='selected']").text == hValueSet[sTableType][row.find_element(:xpath => "./th").text][aStep2Headers[4]])
                    row.find_elements(:xpath => "./td[4]/select/option").each do |option|
                      if option.text == hValueSet[sTableType][row.find_element(:xpath => "./th").text][aStep2Headers[4]]
                        option.click
                        blnReturn=true
                        break
                      end
                    end
                  end
                end
                # hStep2SubRowResp[aStep2Headers[4]] = row.find_element(:xpath => "./td[4]/select/option[@selected='selected']").text unless row.find_elements(:xpath => "./td[4]//*").size == 0
              end

              # srowFieldLabel=row.find_element(:xpath => "./th").text
              # hStep2SubRowResp[aStep2Headers[1]]=row.find_element(:xpath => "./td[1]/input").attribute("value") unless row.find_elements(:xpath => "./td[1]//*").size == 0
              # hStep2SubRowResp[aStep2Headers[2]]=row.find_element(:xpath => "./td[2]/input").attribute("value") unless row.find_elements(:xpath => "./td[2]//*").size == 0
              # hStep2SubRowResp[aStep2Headers[3]]=row.find_element(:xpath => "./td[3]/select/option[@selected='selected']").text unless row.find_elements(:xpath => "./td[3]//*").size == 0
              # if row.find_element(:xpath => "./td[4]").attribute("class") == " dataCell  booleanColumn"
              #   # - get checkbox value
              #   hStep2SubRowResp[aStep2Headers[4]] = !row.find_element(:xpath => "./td[4]/input").attribute("checked").nil? 
              # else
              #   # - Get gender value
              #   hStep2SubRowResp[aStep2Headers[4]] = row.find_element(:xpath => "./td[4]/select/option[@selected='selected']").text unless row.find_elements(:xpath => "./td[4]//*").size == 0
              # end
            end
          end
        end

        iTableCount +=1
      end

      @driver.manage.timeouts.implicit_wait = @implicitWait
      
      return blnReturn
    end
    # -----------------------------

  end
end