# -----------------------------------------------
# - Page: Setup Navigation Bar (left hand side) -
# -----------------------------------------------

module SfdcSe
  class Driver
  	# <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
  	# ------------------------------------------------------------
	# ---- Under the Personal Setup Section of the Setup Menu ----
	# ------------------------------------------------------------
	# <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

	# -----------------------------
	# click_MyPersonalInformation_icon
	# => Clicks the arrow icon for 'My Personal Information' from the Setup Menu
	#
	def click_MyPersonalInformation_icon
		@driver.find_element(:id => 'PersonalInfo_icon').click if @driver.find_element(:id => 'PersonalInfo').attribute("class") == "parent"
	end

	# -----------------------------
	# click_MyPersonalInformation
	# => Clicks the link for 'My Personal Information' from the Setup Menu
	#
	def click_MyPersonalInformation
		@driver.find_element(:id => 'PersonalInfo_font').click
	end

	# -----------------------------
	# click_MyPersonalInformation_PersonalInformation
	# => Clicks the Personal Information link under My Personal Information from the Setup Menu
	#
	def click_MyPersonalInformation_PersonalInformation
		@driver.find_element(:id => 'PersonalInformation_font').click
	end

	# -----------------------------
	# navigate_MyPersonalInformation_PersonalInformation
	# => Navigates to the Personal Information page
	#
	def navigate_MyPersonalInformation_PersonalInformation
		click_MyPersonalInformation_icon
		click_MyPersonalInformation_PersonalInformation
	end

	# <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
	# ------------------------------------------------------
	# ----Under the App Setup Section of the Setup Menu ----
	# ------------------------------------------------------
	# <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

	# ---------------------------
	# ---- Customize Section ----
	# ---------------------------

	# -----------------------------
	# click_Customize_icon
	# => Clicks the arrow icon for Customize from the Setup Menu
	#
	def click_Customize_icon
		@driver.find_element(:id => "Customize_icon").click if @driver.find_element(:id => "Customize").attribute("class") == "parent"
	end
	# -----------------------------

	# -----------------------------
	# click_Customize
	# => Clicks the link for Customize from the Setup Menu
	#
	def click_Customize
		@driver.find_element(:link_text => "Customize").click
	end
	# -----------------------------

	# -----------------------------
	# click_Home_icon
	# => Clicks the arrow icon for Home from the Setup Menu
	#
	def click_Home_icon
		@driver.find_element(:id => "Home_icon").click if @driver.find_element(:id => "Home").attribute("class") == "parent"
	end
	# -----------------------------

	# -----------------------------
	# click_Home
	# => Clicks the link for Home from the Setup Menu
	#
	def click_Home
		@driver.find_element(:id => "Home_font").click
	end
	# -----------------------------

	# -----------------------------
	# click_HomePageLayouts
	# => Clicks the link for Home Page Layouts from the Setup Menu
	#
	def click_HomePageLayouts
		@driver.find_element(:id => "HomePageLayouts_font").click
	end
	# -----------------------------

	# -----------------------------
	# navigate_Customize_Home_HomePageLayouts
	#
	def navigate_Customize_Home_HomePageLayouts
		click_Customize_icon
		click_Home_icon
		click_HomePageLayouts
	end
	# -----------------------------

	# -----------------------------
	# click_Create_icon
	# => Clicks the arrow icon for Create from the Setup Menu
	#
	def click_Create_icon
		@driver.find_element(:id => "DevTools_icon").click if @driver.find_element(:xpath => "//div[@id='DevTools']/a/img").attribute("title").include? "Expand"
	end
	# -----------------------------

	# -----------------------------
	# click_WorkflowApprovals_icon
	# => Clicks the arrow icon for Workflow & Approvals from the Setup Menu
	#
	def click_WorkflowApprovals_icon
		@driver.find_element(:id => "Workflow_icon").click if @driver.find_element(:xpath => "//a[@id='Workflow_icon']/img").attribute("title").include? "Expand"
	end
	# -----------------------------

	# -----------------------------
	# click_EmailAlerts
	# => Clicks the link for Email Alerts from the Setup Menu
	#
	def click_EmailAlerts
		@driver.find_element(:id => "WorkflowEmails_font").click
	end
	# -----------------------------

	# -----------------------------
	# click_FieldUpdates
	# => Clicks the link for Field Updates from the Setup Menu
	#
	def click_FieldUpdates
		@driver.find_element(:id => "WorkflowFieldUpdates_font").click
	end
	# -----------------------------

	# -----------------------------
	# navigate_Create_WorkflowApprovals_EmailAlerts
	# => Navigates to the Create > Workflow & Approvals > Email Alerts from the Setup Menu
	#
	def navigate_Create_WorkflowApprovals_EmailAlerts
		click_Create_icon
		click_WorkflowApprovals_icon
		click_EmailAlerts
	end
	# -----------------------------

	# -----------------------------
	# navigate_Create_WorkflowApprovals_FieldUpdates
	# => Navigates to the Create > Workflow & Approvals > Field Updates from the Setup Menu
	#
	def navigate_Create_WorkflowApprovals_FieldUpdates
		click_Create_icon
		click_WorkflowApprovals_icon
		click_FieldUpdates
	end
	# -----------------------------

	# -----------------------------
	# click_TabNamesLabels_arrow
	# => Clicks the arrow icon for Tab Names and Labels from the Setup Menu
	#
	def click_TabNamesLabels_arrow
		@driver.find_element(:id => "Tab_icon").click if @driver.find_element(:id => "Tab").attribute("class") == "parent"
	end
	# -----------------------------

	# -----------------------------
	# click_RenameTabsLabels_TabNamesLabels
	# => Clicks the link for Rename Tabs and Labels from the Setup Menu
	#
	def click_RenameTabsLabels_TabNamesLabels
		@driver.find_element(:id => "RenameTab_font").click
	end
	# -----------------------------

	# -----------------------------
	# navigate_Customize_TabNamesLabels_RenameTabsLabels
	# => Navigates to the Customize > Tab Names and Labels > Rename Tabs and Labels from the Setup Menu
	#
	def navigate_Customize_TabNamesLabels_RenameTabsLabels
		click_Customize_icon
		click_TabNamesLabels_arrow
		click_RenameTabsLabels_TabNamesLabels
	end
	# -----------------------------

  	# <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
  	# ------------------------------------------------------------------
  	# ---- Under the Administration Setup Section of the Setup Menu ----
  	# ------------------------------------------------------------------
  	# <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

  	# -----------------------------
  	# click_ManageUsers_arrow
  	# => Clicks the arrow icon for Manage Users from the Setup Menu
  	#
  	def click_ManageUsers_arrow
  		@driver.find_element(:id => 'Users_icon').click if @driver.find_element(:xpath => "//a[@id='Users_icon']/img").attribute("title").include? "Expand"
	end
	# -----------------------------

	# -----------------------------
  	# click_Manageusers_Profiles
  	# => Clicks the Profiles link under Manager Users from the Setup Menu
  	#
  	def click_Manageusers_Profiles
  		# -- Click the 'arrow icon' for Manage Users from Setup Nav Bar
		@driver.find_element(:id => 'EnhancedProfiles_font').click
	end
	# -----------------------------

	# -----------------------------
	# navigate_ManageUsers_Profiles
	# => Navigates to the Manage Users Profiles page
	#
	def navigate_ManageUsers_Profiles
		click_ManageUsers_arrow
		click_Manageusers_Profiles
	end
	# -----------------------------

  	# -----------------------------
  	# click_EmailAdministration_icon
  	# => Clicks the arrow icon for Email Administration from the Setup Menu
  	#
  	def click_EmailAdministration_icon
  		# -- Click the 'arrow icon' for Email Administration from Setup Nav Bar
		@driver.find_element(:id => 'EmailAdmin_icon').click if @driver.find_element(:id => 'EmailAdmin').attribute("class") == "parent"
	end
	# -----------------------------

	# -----------------------------
	# click_EmailAdministration_Deliverability
	# => Clicks the Deliverability link under Email Administration from the Setup Menu
	#
	def click_EmailAdministration_Deliverability
		# -- Click the 'Deliverability' from the Setup Nav Bar
		@driver.find_element(:id => 'OrgEmailSettings_font').click
	end
	# -----------------------------

	# -----------------------------
	# navigate_EmailAdministration_Deliverability
	# => Navigates to the Email Administration Deliverability page
	#
	def navigate_EmailAdministration_Deliverability
		click_EmailAdministration_icon
		click_EmailAdministration_Deliverability
	end
	# -----------------------------

	# -----------------------------
	# click_SecurityControls_arrow
	# => Clicks the arrow icon for Security Controls under Administrative Setup from the Setup Menu
	#
	def click_SecurityControls_arrow
		@driver.find_element(:id => 'Security_icon').click if @driver.find_element(:id => 'Security').attribute("class") == "parent"
	end
	# -----------------------------

	# -----------------------------
	# click_SharingSettings_SecurityControls
	# => Clicks the Sharing Settings link under Security Controls from the Setup Menu
	#
	def click_SharingSettings_SecurityControls
		@driver.find_element(:id => 'SecuritySharing_font').click
	end
	# -----------------------------

	# -----------------------------
	# navigate_SecurityControls_SharingSettings
	# => Navigates to the Security Control > Sharing Settings page
	#
	def navigate_SecurityControls_SharingSettings
		click_SecurityControls_arrow
		click_SharingSettings_SecurityControls
	end
	# -----------------------------

	# -----------------------------
	# click_TranslationWorkbench_arrow
	# => Clicks the arrow icon for Translations Workbench under Administrative Setup from the Setup Menu
	#
	def click_TranslationWorkbench_arrow
		# @driver.find_element(:id => 'LabelWorkbench_icon').click if @driver.find_element(:id => 'LabelWorkbench').attribute("class") == "parent"
		@driver.find_element(:id => 'LabelWorkbench_icon').click if @driver.find_element(:xpath => "//a[@id='LabelWorkbench_icon']/img").attribute("title").include? "Expand"
	end
	# -----------------------------

	# -----------------------------
	# click_Translate_TranslationWorkbench
	# => Clicks the Translate link under Translation Workbench from the Setup Menu
	#
	def click_Translate_TranslationWorkbench
		@driver.find_element(:id => 'LabelWorkbenchTranslate_font').click
	end
	# -----------------------------

	# -----------------------------
	# navigate_TranslationWorkbench_Translate
	# => Navigates to Translation Workbench > Translate from the Setup Menu
	#
	def navigate_TranslationWorkbench_Translate
		click_TranslationWorkbench_arrow
		click_Translate_TranslationWorkbench
	end
	# -----------------------------

  end
end	