# ----------------------------------------------
# - Page: Translate	
# ----------------------------------------------

module SfdcSe
  class Driver
  	
  	# -----------------------------
  	# get_Translate_Language
  	# => returns all the elements for the Translate Language dropdown
  	#
  	def get_Translate_Language
		return @driver.find_elements(:xpath => "//div[@id='twb:theForm:filterBlock:filterPageBlock']/div/table/tbody/tr[1]/td/span/select/option")
  	end
  	# -----------------------------

  	# -----------------------------
  	# get_Translate_SetupComponent
  	# => returns all the elements for the Translate Setup Comonent dropdown
  	#
  	def get_Translate_SetupComponent
		return @driver.find_elements(:xpath => "//div[@id='twb:theForm:filterBlock:filterPageBlock']/div/table/tbody/tr[2]/td/span/select/option")
  	end
  	# -----------------------------

  	# -----------------------------
  	# get_Translate_CustomReportTypeEntity
  	# => returns all the elements for the Translate Custom Report Type Entity dropdown
  	#
  	def get_Translate_CustomReportTypeEntity
		return @driver.find_elements(:xpath => "//div[@id='twb:theForm:filterBlock:filterPageBlock']/div/table/tbody/tr[3]/td/span/select/option")
  	end
  	# -----------------------------

  	# -----------------------------
  	# get_Translate_Aspect
  	# => returns all the elements for the Translate Aspect dropdown
  	#
  	def get_Translate_Aspect
		return @driver.find_elements(:xpath => "//div[@id='twb:theForm:filterBlock:filterPageBlock']/div/table/tbody/tr[4]/td/span/select/option")
  	end
  	# -----------------------------

  	# -----------------------------
  	# get_Translate_CustomReportType_FieldLabel_rows
  	# => returns all the elements for the Translate Custom Report Type - Field Label rows
  	#
  	def get_Translate_CustomReportType_FieldLabel_rows
  		return @driver.find_elements(:xpath => "//div[@id='gridID']/div[1]/div[2]/div[1]/div[1]/div[2]/div/div")
	end
  	# -----------------------------

  	# -----------------------------
  	# get_btn_Translate_CustomReportType_FieldLabel_Next
  	# => returns the element for the Translate Custom Report Type - Field Label Next button
  	#
  	def get_btn_Translate_CustomReportType_FieldLabel_Next
  		return @driver.find_element(:xpath => "//table[@id='nextTextBtn']/tbody/tr[2]/td[2]/em/button")
	  end
  	# -----------------------------

    # -----------------------------
    # click_btn_Translate_Save
    #
    def click_btn_Translate_Save
      @driver.find_element(:xpath => "//table[@id = 'saveBtn']/tbody/tr[2]/td[2]/em/button").click
      sleep(5)
    end
    # -----------------------------

  	# -----------------------------
  	# set_Translation_Language
  	# => sLanguage = string value of the Translate Language option to select
    # => Return = true or false
    # =>    true  = setting of view were successful
    # =>    false = setting of view had an error
    #
  	def set_Translation_Language(sLanguage)
  	  	blnReturn=false

  	  	begin
  			get_Translate_Language.each do |option|
  				if option.text == sLanguage
  					option.click unless option.selected?
  					blnReturn=true
  					sleep(3)
  					break
  				end
  			end
  		rescue
  			puts $!
	    	puts $@
  		end
  		return blnReturn
  	end
  	# -----------------------------

	# -----------------------------
  	# set_Translation_SetupComponent
  	# => sComponentName = string value of the Translate Setup Component option to select
    # => Return = true or false
    # =>    true  = setting of view were successful
    # =>    false = setting of view had an error
    #
  	def set_Translation_SetupComponent(sComponentName)
  	  	blnReturn=false

  	  	begin
  			get_Translate_SetupComponent.each do |option|
  				if option.text == sComponentName
  					option.click unless option.selected?
  					blnReturn=true
  					sleep(3)
  					break
  				end
  			end
  		rescue
  			puts $!
	    	puts $@
  		end
  		return blnReturn
  	end
  	# -----------------------------

  	# -----------------------------
  	# set_Translation_CustomReportTypeEntity
  	# => sEntityType = string value of the Translate Custom Report Type Entity option to select
    # => Return = true or false
    # =>    true  = setting of view were successful
    # =>    false = setting of view had an error
    #
  	def set_Translation_CustomReportTypeEntity(sEntityType)
  	  	blnReturn=false

  	  	begin
  			get_Translate_CustomReportTypeEntity.each do |option|
  				if option.text == sEntityType
  					option.click unless option.selected?
  					blnReturn=true
  					sleep(3)
  					break
  				end
  			end
  		rescue
  			puts $!
	    	puts $@
  		end
  		return blnReturn
  	end
  	# -----------------------------

  	#-----------------------------
  	# set_Translation_Aspect
  	# => sAspect = string value of the Translate Aspect option to select
    # => Return = true or false
    # =>    true  = setting of view were successful
    # =>    false = setting of view had an error
    #
  	def set_Translation_Aspect(sAspect)
  	  	blnReturn=false

  	  	begin
  			get_Translate_Aspect.each do |option|
  				if option.text == sAspect
  					option.click unless option.selected?
  					blnReturn=true
  					sleep(3)
  					break
  				end
  			end
  		rescue
  			puts $!
	    	puts $@
  		end
  		return blnReturn
  	end
  	# -----------------------------

  	# -----------------------------
  	# get_Translation_CustomReportType_FieldLabel
  	# => Return = Hash {Key= Field Name/Type, Value=Field Value}
  	#
  	def get_Translation_CustomReportType_FieldLabel(sCustomReportTypeName)
  		response=Hash.new
  		blnFound=false
  		idx=0

  		until (@driver.find_element(:id => 'pageNumField').attribute("value").to_i == @driver.find_element(:id => 'totalPages').text.to_i and idx==@driver.find_element(:id => 'totalPages').text.to_i) or blnFound==true
  			r=0
  			while r < get_Translate_CustomReportType_FieldLabel_rows.length
	  			if get_Translate_CustomReportType_FieldLabel_rows[r].find_element(:xpath => "./table/tbody/tr/td[1]/div").text == sCustomReportTypeName
	  				response["translation"]=get_Translate_CustomReportType_FieldLabel_rows[r].find_element(:xpath => "./table/tbody/tr/td[2]/div").text
	  				# response["out of Date"]=get_Translate_CustomReportType_FieldLabel_rows[r].find_element(:xpath => "./table/tbody/tr/td[4]/div/div/input").selected? #attribute("checked")
	  				blnFound=true
	  				break
	  			end
	  			r+=1
	  		end
	  		idx+=1
	  		if blnFound==false
		  		get_btn_Translate_CustomReportType_FieldLabel_Next.click unless @driver.find_element(:id => 'pageNumField').attribute("value").to_i == @driver.find_element(:id => 'totalPages').text.to_i
		  		sleep(5)
		  	end
  		end

  		return response
  	end
  	# -----------------------------

    # -----------------------------
    # set_Translation_CustomReportType_FieldLabel
    # => Return = true/false
    #
    def set_Translation_CustomReportType_FieldLabel(sCustomReportTypeName, sTranslationValue)
      blnReturn=false
      blnFound=false
      idx=0

      until (@driver.find_element(:id => 'pageNumField').attribute("value").to_i == @driver.find_element(:id => 'totalPages').text.to_i and idx==@driver.find_element(:id => 'totalPages').text.to_i) or blnFound==true
        r=0
        while r < get_Translate_CustomReportType_FieldLabel_rows.length
          if get_Translate_CustomReportType_FieldLabel_rows[r].find_element(:xpath => "./table/tbody/tr/td[1]/div").text == sCustomReportTypeName
            if !(get_Translate_CustomReportType_FieldLabel_rows[r].find_element(:xpath => "./table/tbody/tr/td[2]/div").text == sTranslationValue)
              @driver.action.double_click(get_Translate_CustomReportType_FieldLabel_rows[r].find_element(:xpath => "./table/tbody/tr/td[2]/div")).perform
              @driver.find_element(:id => "txtEdField").clear()
              @driver.find_element(:id => "txtEdField").send_keys(sTranslationValue)
              blnReturn=true
            end
            blnFound=true
            break
          end
          r+=1
        end
        idx+=1
        if blnFound==false
          get_btn_Translate_CustomReportType_FieldLabel_Next.click unless @driver.find_element(:id => 'pageNumField').attribute("value").to_i == @driver.find_element(:id => 'totalPages').text.to_i
          sleep(5)
        end
      end

      return blnReturn
    end
    # -----------------------------

  	# -----------------------------
  	# get_Translation_CustomReportType_Description
  	# => Return = Hash {Key= Field Name/Type, Value=Field Value}
  	#
  	def get_Translation_CustomReportType_Description(sCustomReportTypeName)
  		response=Hash.new
  		blnFound=false
  		idx=0

  		until (@driver.find_element(:id => 'pageNumField').attribute("value").to_i == @driver.find_element(:id => 'totalPages').text.to_i and idx==@driver.find_element(:id => 'totalPages').text.to_i) or blnFound==true
  			r=0
  			while r < get_Translate_CustomReportType_FieldLabel_rows.length
	  			if get_Translate_CustomReportType_FieldLabel_rows[r].find_element(:xpath => "./table/tbody/tr/td[1]/div").text == sCustomReportTypeName
	  				response["translation"]=get_Translate_CustomReportType_FieldLabel_rows[r].find_element(:xpath => "./table/tbody/tr/td[2]/div").text
	  				# response["out of Date"]=get_Translate_CustomReportType_FieldLabel_rows[r].find_element(:xpath => "./table/tbody/tr/td[4]/div/div/input").selected? #attribute("checked")
	  				blnFound=true
	  				break
	  			end
	  			r+=1
	  		end
	  		idx+=1
	  		if blnFound==false
		  		get_btn_Translate_CustomReportType_FieldLabel_Next.click unless @driver.find_element(:id => 'pageNumField').attribute("value").to_i == @driver.find_element(:id => 'totalPages').text.to_i
		  		sleep(5)
		  	end
  		end
  		
  		return response
  	end
  	# -----------------------------

    # -----------------------------
    # set_Translation_CustomReportType_Description
    # => Return = true/false
    #
    def set_Translation_CustomReportType_Description(sCustomReportTypeName, sTranslationValue)
      blnReturn=false
      blnFound=false
      idx=0

      until (@driver.find_element(:id => 'pageNumField').attribute("value").to_i == @driver.find_element(:id => 'totalPages').text.to_i and idx==@driver.find_element(:id => 'totalPages').text.to_i) or blnFound==true
        r=0
        while r < get_Translate_CustomReportType_FieldLabel_rows.length
          if get_Translate_CustomReportType_FieldLabel_rows[r].find_element(:xpath => "./table/tbody/tr/td[1]/div").text == sCustomReportTypeName
            if !(get_Translate_CustomReportType_FieldLabel_rows[r].find_element(:xpath => "./table/tbody/tr/td[2]/div").text == sTranslationValue)
              @driver.action.double_click(get_Translate_CustomReportType_FieldLabel_rows[r].find_element(:xpath => "./table/tbody/tr/td[2]/div")).perform
              @driver.find_element(:id => "txtEdField").clear()
              @driver.find_element(:id => "txtEdField").send_keys(sTranslationValue)
              blnReturn=true
            end

            # response["translation"]=get_Translate_CustomReportType_FieldLabel_rows[r].find_element(:xpath => "./table/tbody/tr/td[2]/div").text
            # response["out of Date"]=get_Translate_CustomReportType_FieldLabel_rows[r].find_element(:xpath => "./table/tbody/tr/td[4]/div/div/input").selected? #attribute("checked")
            blnFound=true
            break
          end
          r+=1
        end
        idx+=1
        if blnFound==false
          get_btn_Translate_CustomReportType_FieldLabel_Next.click unless @driver.find_element(:id => 'pageNumField').attribute("value").to_i == @driver.find_element(:id => 'totalPages').text.to_i
          sleep(5)
        end
      end
      
      return blnReturn
      # return response
    end
    # -----------------------------

  	# -----------------------------
  	# get_Translation_CustomReportType_LayoutSection
  	# => Return = Hash {Key= Field Name/Type, Value=Field Value}
  	#
  	def get_Translation_CustomReportType_LayoutSection(sMasterLayoutSection, sCustomReportTypeName)
  		response=Hash.new
  		blnFound=false
  		idx=0

  		until (@driver.find_element(:id => 'pageNumField').attribute("value").to_i == @driver.find_element(:id => 'totalPages').text.to_i and idx==@driver.find_element(:id => 'totalPages').text.to_i) or blnFound==true
  			r=0
  			while r < get_Translate_CustomReportType_FieldLabel_rows.length
	  			if get_Translate_CustomReportType_FieldLabel_rows[r].find_element(:xpath => "./table/tbody/tr/td[1]/div").text == sMasterLayoutSection and get_Translate_CustomReportType_FieldLabel_rows[r].find_element(:xpath => "./table/tbody/tr/td[3]/div").text == sCustomReportTypeName
	  				response["translation"]=get_Translate_CustomReportType_FieldLabel_rows[r].find_element(:xpath => "./table/tbody/tr/td[2]/div").text
	  				# response["out of Date"]=get_Translate_CustomReportType_FieldLabel_rows[r].find_element(:xpath => "./table/tbody/tr/td[4]/div/div/input").selected? #attribute("checked")
	  				blnFound=true
	  				break
	  			end
	  			r+=1
	  		end
	  		idx+=1
	  		if blnFound==false
		  		get_btn_Translate_CustomReportType_FieldLabel_Next.click unless @driver.find_element(:id => 'pageNumField').attribute("value").to_i == @driver.find_element(:id => 'totalPages').text.to_i
		  		sleep(5)
		  	end
  		end
  		
  		return response
  	end
  	# -----------------------------

    # -----------------------------
    # set_Translation_CustomReportType_LayoutSection
    # => Return = true / false
    #
    def set_Translation_CustomReportType_LayoutSection(sMasterLayoutSection, sCustomReportTypeName, sTranslationValue)
      blnReturn=false
      blnFound=false
      idx=0

      until (@driver.find_element(:id => 'pageNumField').attribute("value").to_i == @driver.find_element(:id => 'totalPages').text.to_i and idx==@driver.find_element(:id => 'totalPages').text.to_i) or blnFound==true
        r=0
        while r < get_Translate_CustomReportType_FieldLabel_rows.length
          if get_Translate_CustomReportType_FieldLabel_rows[r].find_element(:xpath => "./table/tbody/tr/td[1]/div").text == sMasterLayoutSection and get_Translate_CustomReportType_FieldLabel_rows[r].find_element(:xpath => "./table/tbody/tr/td[3]/div").text == sCustomReportTypeName
            if !(get_Translate_CustomReportType_FieldLabel_rows[r].find_element(:xpath => "./table/tbody/tr/td[2]/div").text == sTranslationValue)
              @driver.action.double_click(get_Translate_CustomReportType_FieldLabel_rows[r].find_element(:xpath => "./table/tbody/tr/td[2]/div")).perform
              @driver.find_element(:id => "txtEdField").clear()
              @driver.find_element(:id => "txtEdField").send_keys(sTranslationValue)
              blnReturn=true
            end
            blnFound=true
            break
          end
          r+=1
        end
        idx+=1
        if blnFound==false
          get_btn_Translate_CustomReportType_FieldLabel_Next.click unless @driver.find_element(:id => 'pageNumField').attribute("value").to_i == @driver.find_element(:id => 'totalPages').text.to_i
          sleep(5)
        end
      end
      
      return blnReturn
    end
    # -----------------------------

  	# -----------------------------
  	# get_Translation_RecordType
  	# => Return = Hash {Key= Field Name/Type, Value=Field Value}
  	#
  	def get_Translation_RecordType(sMasterRecordTypeLabel)
  		response=Hash.new
  		blnFound=false
  		idx=0

  		until (@driver.find_element(:id => 'pageNumField').attribute("value").to_i == @driver.find_element(:id => 'totalPages').text.to_i and idx==@driver.find_element(:id => 'totalPages').text.to_i) or blnFound==true
  			r=0
  			while r < get_Translate_CustomReportType_FieldLabel_rows.length
	  			if get_Translate_CustomReportType_FieldLabel_rows[r].find_element(:xpath => "./table/tbody/tr/td[1]/div").text == sMasterRecordTypeLabel
	  				response["translation"]=get_Translate_CustomReportType_FieldLabel_rows[r].find_element(:xpath => "./table/tbody/tr/td[2]/div").text
	  				# response["out of Date"]=get_Translate_CustomReportType_FieldLabel_rows[r].find_element(:xpath => "./table/tbody/tr/td[4]/div/div/input").selected? #attribute("checked")
	  				blnFound=true
	  				break
	  			end
	  			r+=1
	  		end
	  		idx+=1
	  		if blnFound==false
		  		get_btn_Translate_CustomReportType_FieldLabel_Next.click unless @driver.find_element(:id => 'pageNumField').attribute("value").to_i == @driver.find_element(:id => 'totalPages').text.to_i
		  		sleep(5)
		  	end
  		end
  		
  		return response
  	end
  	# -----------------------------

    # -----------------------------
    # set_Translation_RecordType
    # => Return = true/ false
    #
    def set_Translation_RecordType(sMasterRecordTypeLabel, sTranslationValue)
      blnReturn=false
      blnFound=false
      idx=0

      until (@driver.find_element(:id => 'pageNumField').attribute("value").to_i == @driver.find_element(:id => 'totalPages').text.to_i and idx==@driver.find_element(:id => 'totalPages').text.to_i) or blnFound==true
        r=0
        while r < get_Translate_CustomReportType_FieldLabel_rows.length
          if get_Translate_CustomReportType_FieldLabel_rows[r].find_element(:xpath => "./table/tbody/tr/td[1]/div").text == sMasterRecordTypeLabel
            if !(get_Translate_CustomReportType_FieldLabel_rows[r].find_element(:xpath => "./table/tbody/tr/td[2]/div").text == sTranslationValue)
              @driver.action.double_click(get_Translate_CustomReportType_FieldLabel_rows[r].find_element(:xpath => "./table/tbody/tr/td[2]/div")).perform
              @driver.find_element(:id => "txtEdField").clear()
              @driver.find_element(:id => "txtEdField").send_keys(sTranslationValue)
              blnReturn=true
            end

            # response["translation"]=get_Translate_CustomReportType_FieldLabel_rows[r].find_element(:xpath => "./table/tbody/tr/td[2]/div").text
            # response["out of Date"]=get_Translate_CustomReportType_FieldLabel_rows[r].find_element(:xpath => "./table/tbody/tr/td[4]/div/div/input").selected? #attribute("checked")
            blnFound=true
            break
          end
          r+=1
        end
        idx+=1
        if blnFound==false
          get_btn_Translate_CustomReportType_FieldLabel_Next.click unless @driver.find_element(:id => 'pageNumField').attribute("value").to_i == @driver.find_element(:id => 'totalPages').text.to_i
          sleep(5)
        end
      end
      
      return blnReturn
    end
    # -----------------------------

  end
end